#include <stdio.h>
#include <ctype.h>
#include <errno.h>
#include <memory.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/param.h>
#include <fcntl.h>

typedef  unsigned char  uchar;

#define   VERSION_FUNCTION  "20040229"

// 
#define   SERV_MSGLEN  4096   // ̿
#define   SERV_TOP     "|<"   // ץȥ prefix
#define   SERV_END     ">|"   // ץȥ suffix
#define   SERV_TOPLEN     2   // SERV_TOPĹ
#define   SERV_ENDLEN     2   // SERV_ENDĹ

// ʸѥ
#define   MAX_PTNID             12   // ѥIDκĹ + 1
#define   MAX_PATN          500000   // ѥ
#define   MAX_FACT         5000000   // ǿ   (ѥ)
#define   MAX_NEST              10   // Ǥǥͥȿ (ѥ󤢤)
#define   MAX_CAT               10   // ̣° (ѿ)
#define   MAX_PSTRING      2000000   // ʸĹ (ѥ)
#define   MAX_PWORDS        100000   // ʸθĿ (ѥ)
#define   MAX_IMIZ_ALL      200000   // ̣°ǿ (ѥ)
#define   MAX_IMIZ             127   // ̣° (°)
#define   MAX_NODE_ALL     7000000   // Ρɿ (ѥ)
#define   MAX_ARC               16   // Ρɿ
#define   MAX_ARCLIST      5000000   // 祢ꥹȿ
#define   MAX_JMAP              12   // ̥ޥåפκʸ(1ʸ󤢤)

#define   MAX_FUNCG_ALL     200000   // °ؿ(ѥ)
#define   MAX_FUNCG             10   // °ؿ(ѿ)

#define   MAX_zCOND            512   // ѿ/ؿ    ()
#define   MAX_zVALU             10   // ѿ/ؿ Ϳ ()

#define   MAX_COND             127   // ѿ/ؿ    ()
#define   MAX_VALU              10   // ѿ/ؿ Ϳ ()

// ѿ/ؿ
#define   MAX_nARC              20   // Aѿ (Ρɤ)
#define   MAX_FSTRING       100000   // ʸĹ (ǡ)
#define   MAX_FWORDS         20000   // ʸθĿ (ǡ)

// ʸ
#define   MAX_jMORP             80   // ʸηǿ
#define   MAX_jINFO              8   // ǤβϾ
#define   A1A1               41377   // 0xA1A1 10ʿ

// ӷѿؿؿ
typedef  struct xVARS  xVARS_t;
typedef  struct gFUNC  gFUNC_t;

// ѿ
typedef  struct aVARA  aVARA_t;
typedef  struct aNODE  aNODE_t;
typedef  struct aARC   aARC_t;

// ʸ()
typedef  struct jMORP  jMORP_t;
typedef  struct jINFO  jINFO_t;

// ʸѥ
typedef  struct  pBASE  pBASE_t;
typedef  struct  pPATN  pPATN_t;
typedef  struct  pFACT  pFACT_t;
typedef  struct  pIMIZ  pIMIZ_t;
typedef  struct  pNODE  pNODE_t;

//----------------------------------------------------------------------------
// ʸѥ pBASE pPATN pFACT
//----------------------------------------------------------------------------
struct pIMIZ { // ̣°
  char   NIc;  // ϿĿ NI
  char   NKc;  // ϿĿ NK
  char   NYc;  // ϿĿ NY
  char   KRc;  // ϿĿ KR

  char   NIm[MAX_IMIZ];  // 1 = NIx, NIy ޥʥ
  char   NKm[MAX_IMIZ];  // 1 = NKx, NKy ޥʥ
  char   NYm[MAX_IMIZ];  // 1 = NYx, NYy ޥʥ

  short  NIx[MAX_IMIZ];  // NI min
  short  NIy[MAX_IMIZ];  //    max

  char   NKx[MAX_IMIZ];  // NK min
  char   NKy[MAX_IMIZ];  // NK max

  char   NYx[MAX_IMIZ];  // NY min
  char   NYy[MAX_IMIZ];  // NY mx

  char   KR [MAX_IMIZ][8];
};

struct pBASE{ // 
  int       all_patn;     // ѥο
  int       all_fact;     // Ǿο
  int       all_node;     // Ρɤο
  int       all_jmap;     // ɬܻ  ݷ (patternǥå)

  pPATN_t  *base_patn;    // Ƭѥ
  pFACT_t  *base_fact;    // Ƭ    
  pNODE_t  *base_node;    // ƬΡ
  short    *base_jmap;    // ɬܻ̥ޥå (matchingǻ)

  pNODE_t **arclist;      // ARCLIST
  char     *pstring;      // PSTRING;
  char     *fstring;      // FSTRING;
  pIMIZ_t  *categories;   // CATEGORIES
  gFUNC_t  *funcg;        // FUNCG

  FILE     *fp;           // ʸѥե롦ǥץ
};

struct pNODE {
  int       nseq;           // Ρֹ
  char      vsym;           // ֲѵ ($n  n)
  char      vseq;           // ֲѵ (и)
  short     cnt_arc;        // factξ򥯥ꥢȤʬ
  pFACT_t  *fact;           // ʬ
  union {
    pNODE_t  *node;         // ʬݥ       (cnt_arc = 1)
    pNODE_t **list;         // ʬݥ󥿥ꥹ (cnt_arc > 1)
  } arcn;
};

struct gFUNC { // ѿ˽°ؿ
  char     gc;                // ؿο
  char     *name[MAX_FUNCG];  // ؿ̾
  xVARS_t  *ptr [MAX_FUNCG];  // ؿΰݥ
};

struct pPATN {  // ʸѥ
  char      id[MAX_PTNID];  // ѥID
  char      filler;
  char      cnt_fact;       // Ǥο
  char      last_fn;        // ǽȹֹ
  short     cnt_arc;        // ʬΡɿ (befͭʤ1)
  short     cnt_jmap;       // ɬܻ̥ޥåפθĿ
  short    *jmap;           // ɬܻ̥ޥå(cnt_jmapĤΥޥåפ³)
  pFACT_t  *top_fact;       // Ƭ ( cnt_factĤpFACT³)
  union {
    pNODE_t  *node;         // ʬݥ       (cnt_arc = 1)
    pNODE_t **list;         // ʬݥ󥿥ꥹ (cnt_arc > 1)
  } arcp;
  int       fpos;           // ʸѥեа (fseekǻ)
};

struct pFACT { // ѥ
  char     num;        // ֹ
  char     type;       // S A Y J / ! # $ Z M (*1)
  char     mode;       // 0=ȹ 1=ɬ 2=Ǥ 3= (*2)
  char     vnum;       // ѿֹ  type=S or A Τ

  char     top;        // Ƭֹ (*3)
  char     end;        // ǽֹ (*3)

  char     snum;       // ǤΥ롼ֹ
  char     styp;       // Ǥζʬ(1/2/3)
  char     zmac;       // ̴ؿ۲(zmac='Z'ֹ)

  uchar   *imag;       // ѥΥ᡼ (ѿ/ؿ̾, , )
  void    *ptr;        // ѿ/ؿΰݥ (*4)
  pIMIZ_t *imiz;       // ̣°  type=S or A Τ
  gFUNC_t *gobi;       // ѿ˽°ؿ
};

/*  (*1)  S : Sѿ      / : Υ            Z : ̴ؿ
          A : Aѿ      ! : ʸᶭ국    M : ޥؿ
          Y : ؿ     # : ϰϻ국
          J :          $ : ֲѻ국
          G : ؿ

     (*2) ǤǤ mode=2

     (*3) #n, $n, ̴ؿ, ޥؿ礹

     (*4) type = S Y  xVARS ؤ
                 A /  aVARA ؤ
*/
//----------------------------------------------------------------------------
// ʸ   jMORP , jINFO
//----------------------------------------------------------------------------
struct jINFO {  // ǲϾ
  char  hink[5];        // ʻ
  char  nhyo[61];       // ɸɽ
  char  katu[61];       // ѷ
  char  snhy[63];       // ' ' + ɸɽ + ' '
  char  skat[63];       // ' ' + ѷ   + ' '
  char  cnt_icat;       // ̣°ͭ (NI)
  char  cnt_kcat;       // ̣°ͭ (NK)
  char  cnt_yzok;       // ̣°ͭ (NY)
  char  cnt_krui;       // ̣°ͭ (KR)
  struct {
    short icat[5];      // ̣°     (NI)
    char  kcat[10];     // ̣°     (NK)
    short ycat[5];      // Ѹƥ (unuse)
    short fcat[5];      //              (unuse)
  } cat;
  char  yzok[MAX_IMIZ];     // ̣° (NY)
  char  krui[MAX_IMIZ][8];  // ̣° (KR)
};

struct jMORP {   // Ǿ
  char     knum;             // ǰϢֹ
  char     flag;             // ʸᶭե饰 (/= +=󶭳)
  char     tang[61];         // ñɽ
  char     stan[63];         // ' ' + ñɽ + ' '

  short    NIc;              // ̣° (NI)
  short    NKc;              // ̣° (NK)
  short    NYc;              // ̣° (NY)
  short    KRc;              // ̣° (KR)

  int      cnt_info;         // ǲϾο
  jINFO_t  info[MAX_jINFO];  // ǲϾ
};
//----------------------------------------------------------------------------
// ѿ & Υ  aVARA , aNODE, 
//----------------------------------------------------------------------------
struct { // 
  int       all_vara;    // ѿ  ο
  int       all_node;    // Ρɤο
  int       all_arc;     // Ρɤο
  aVARA_t  *base_vara;   // ѿ  ΰ
  aNODE_t  *base_node;   // Ρΰ
  aARC_t   *base_arc;    // ΰ
} aBASE;

struct aVARA {
  uchar   *name;      // ѿ̾ (FSTRING)
  char     cnt_node;  // Ρɿ
  aNODE_t *top_node;  // ǽΥΡΰݥ 
};
struct aNODE {
  char     num;       // Ρֹ
  char     cnt_arc;   // ο
  aARC_t  *top_arc;   // ƬؤΥݥ
};
struct aARC {
  char     top;       // Ρֹ
  char     end;       // Ρֹ
  char     type;      // 勵 (*1)
  char     pop;       // 1=pop
  char     opt_i;     // ̣°󻲾 (*  1)
  char     opt_g;     // ؿ     (^  1)
  uchar   *cond;      //   (FSTRING)      (ñɽ/ɸɽ)
  void    *ptr;       // ѿ/ؿ ؤΥݥ (Sѿ/Aѿ/ؿ)
  aNODE_t *endp;      // Ρɥݥ
};

/* (*1) 勵

   T=ñɽ  H=ɸɽ  S=ӷѿ  A=ѿ  G=ؿ  Y=ؿ
   D=ľܹ¤
   p =ǽ٥ (pop)  j =ǽ٥ (jump)  ! =ǽ٥ (!)

*/
//----------------------------------------------------------------------------
// ӷѿؿؿ  xVARS
//----------------------------------------------------------------------------
typedef struct xJMAP  xJMAP_t;

struct xJMAP {  // ̥ޥå
  short    cc;                      // ο       (*1)
  short    mc [MAX_COND];           // ̥ޥåפο (*1)
  short    map[MAX_COND][MAX_JMAP]; // ̥ޥå
};

struct {  // 
  int      all_vars;     // ؿο
  int      all_jmap;     // ̥ޥåפο
  xVARS_t *base_vars;    // ǼΰƬɥ쥹
  xJMAP_t *base_jmap;    // ̥ޥåפƬɥ쥹
} xBASE;

struct xVARS {
  char     type;       // S=Sѿ  G=ؿ  Y=ؿ
  uchar   *name;       // ؿ̾ (FSTRING)

  xJMAP_t *jmap;

  char     ckind;      // 't' or 'h' or 'x'
  char     cnot;       // 1=, 0=
  uchar   *cvalu;      // Ϣ (ctype = 't' or 'h'ΤȤ) (FSTRING)

  short    cc;        //   ο (*1)
  short    vc  [MAX_COND];            // ͤο (*2)
  char     kind[MAX_COND][MAX_VALU];  // 勵 (*3)
  char     proc[MAX_COND][MAX_VALU];  // ֥ե饰 (*4)
  char     not [MAX_COND][MAX_VALU];  // 1=, 0=
  uchar   *valu[MAX_COND][MAX_VALU];  //  (FSTRING)
};

/* (*1) Կ
   (*2) ξͤο
   (*3) T=ñɽ H=ɸɽ P=ʻ쥳 G=
   (*4) 0=Ǥȹо 1=Ǥȹо
*/
//=============================================================================

// Хѿ

uchar *FSTRING;

int    LEN_FSTRING = 0;
int    CNT_FWORDS  = 0;
int    LEN_FWORDS[MAX_FWORDS];

uchar *PSTRING;
int    LEN_PSTRING = 0;
int    CNT_PWORDS  = 0;
int    LEN_PWORDS[MAX_PWORDS];

int      CNT_FUNCG = 0;
gFUNC_t *FUNCG;

int      CNT_CATEGORY = 0;
pIMIZ_t *CATEGORIES;


int       CNT_ARCLIST = 0;
pNODE_t **ARCLIST;

pPATN_t *PATN;                     // Υѥ
char     ORIGINAL_PATTERN[4096];   // Υѥ (string)

char     JPN_ID[512];               // ʸID
char     JPN_SENTENCE[512]   ;     // ʸ
int      CNT_MORP;                 // ǿ
jMORP_t  jBASE[MAX_jMORP];         // Ǿ

// 
int    SERV_PORT=5300;
char   SERV_WHO[256];

// ؿץȥ

int    fc_abort (char [], ...);
uchar *fc_show_image (int size, pFACT_t *fact);
static uchar *fc_substr (uchar *top, uchar *end);

int fc_display_pPATN (char *mark);
int fc_display_pFACT (pFACT_t *fact);
int fc_display_pMATON (uchar *maton);

//-----------------------------------------------------------------------------
int vs (char message[], ...) {

  va_list ap ;
  va_start(ap, message) ;
  vfprintf(stdout, message, ap) ;
  va_end(ap) ;
  fflush(stdout);
}
//-----------------------------------------------------------------------------
int vx (char message[], ...) {

  va_list ap ;
  va_start(ap, message) ;
  vfprintf(stderr, message, ap) ;
  va_end(ap) ;
  fflush(stderr);
}
//-----------------------------------------------------------------------------
void *fc_alloc (char *who, int nmemb, int size) {

  static void *ptr;
  
  if ((ptr = calloc(nmemb, size)) == NULL) {
    fprintf(stderr, ";;; calloc request fails '%s' %d x %d\n",
	    who, nmemb, size);
    exit(-1);
  }

  return(ptr);
}
/*-----------------------------------------------------------------------------
  ʸ src ХȤа֤֤

     (ex.) src = "abcdefg" ---> 6 ֤
                  0123456
-----------------------------------------------------------------------------*/
int  fc_tail_position (uchar *src) {

  return(strlen(src)-1);
}
/*-----------------------------------------------------------------------------
  ʸ src ХȤ֤

     (ex.) src = "abcdefg" ---> 'g' ֤
-----------------------------------------------------------------------------*/
uchar  fc_tail_char (uchar *src) {

  return(*(src+fc_tail_position(src)));
}
/*-----------------------------------------------------------------------------
  ʸ src ХȤ

     (ex.) src = "abcdefg" ---> "abcdef" Ȥ
-----------------------------------------------------------------------------*/
int fc_tail_cut (uchar *src) {

  *(src+fc_tail_position(src)) = 0;
}
/*-----------------------------------------------------------------------------
  ʸ src ٤ʸʤ飱Ǥʤʤ飰֤
-----------------------------------------------------------------------------*/
int fc_zenkaku_p (uchar *src) {

  while (*src) {
    if ((*src < 0xa1) || (*(src+1) < 0xa1)) return 0;
    src += 2;
  }

  return(1);
}
/*-----------------------------------------------------------------------------
  ʸ src ʻ쥳ɷʤ飱Ǥʤʤ飰֤
-----------------------------------------------------------------------------*/
int fc_hinsi_p (uchar *src) {

  int  i;

  if (strlen(src) != 4) return 0;

  for (i=0; i<4; i++) {
    if ((*(src+i) != '.') &&
	(! isxdigit(*(src+i)))) return 0;
  }

  return(1);
}
/*---------------------------------------------------------------------------*/
int fc_load_function (char *mapfile) {

  char   version[256];
  FILE  *fp;

  if ((fp = fopen(mapfile, "r")) == NULL)
    fc_abort(";;; ERROR: file open ؿޥå '%s'\n", mapfile);

  // VERSIONΥ
  fgets(version, 255, fp);
  version[strlen(version)-1] = 0;

  if (strcmp(version, VERSION_FUNCTION) != 0)
    fc_abort(";;; ERROR: verion  ؿޥå '%s'\n", mapfile);

  // FSTRINGΥ
  fc_read(&LEN_FSTRING,   sizeof(int), fp);
  fc_read(&CNT_FWORDS,    sizeof(int), fp);
  fc_read(&LEN_FWORDS[0], MAX_FWORDS,  fp);

  FSTRING = (uchar *)fc_alloc("FSTRING", 1, LEN_FSTRING);

  fc_read(FSTRING, LEN_FSTRING, fp);

  // ؿΥ
  fc_load_xtype(fp);
  fc_load_atype(fp);
}
/*---------------------------------------------------------------------------*/
int fc_load_xtype (FILE *fp) {

  xVARS_t  *vars;
  xJMAP_t  *jmap;
  char     *old_jmap;

  int  i, cc, vc;

  // xBASE 
  fc_read(&xBASE, sizeof(xBASE), fp);

  vars = xBASE.base_vars =
    (xVARS_t *)fc_alloc("xVARS", xBASE.all_vars, sizeof(xVARS_t));

  old_jmap = (char *)xBASE.base_jmap;  // jmapΥɥ쥹

  // jmapΰγ
  xBASE.base_jmap =
    (xJMAP_t *)fc_alloc("xjmap", xBASE.all_jmap, sizeof(xJMAP_t));


  // xVARS  : name & cvalu & valu &jmap а֤饢ɥ쥹Ѵ
  for (i=0; i<xBASE.all_vars; i++) {
    fc_read(vars, sizeof(xVARS_t), fp);
    vars->name = FSTRING + (long)vars->name;
    if (vars->ckind == 'x') {
      for (cc=0; cc<vars->cc; cc++) {
	for (vc=0; vc<vars->vc[cc]; vc++) {
	  vars->valu[cc][vc] = FSTRING + (long)vars->valu[cc][vc];
	}
      }
    }
    else {
      vars->cvalu = FSTRING + (long)vars->cvalu;
    }
    if (vars->jmap) {
      vars->jmap =
	(xJMAP_t *)((char *)vars->jmap - old_jmap + (char *)xBASE.base_jmap);
    }

    vars++;
  }

  // xJMAP 
  jmap = xBASE.base_jmap;
  for (i=0; i<xBASE.all_jmap; i++) {
    fc_read(jmap++, sizeof(xJMAP_t), fp);
  }

  //fc_show_yoso_jmap();
}
/*---------------------------------------------------------------------------*/
int fc_load_atype (FILE *fp) {

  aVARA_t  *vara;
  aNODE_t  *node;
  aARC_t   *arc;

  int  i, j, k;

  // aBASE 
  fc_read(&aBASE, sizeof(aBASE), fp);

  vara = aBASE.base_vara =
    (aVARA_t *)fc_alloc("aVARA", aBASE.all_vara,sizeof(aVARA_t));
  node = aBASE.base_node =
    (aNODE_t *)fc_alloc("aNODE", aBASE.all_node,sizeof(aNODE_t));
  arc  = aBASE.base_arc =
    (aARC_t  *)fc_alloc("aARC", aBASE.all_arc, sizeof(aARC_t));

  // aVARA  : name & top_node а֤饢ɥ쥹Ѵ
  for (i=0; i<aBASE.all_vara; i++) {
    fc_read(vara, sizeof(aVARA_t), fp);
    vara->name = FSTRING + (long)vara->name;
    vara->top_node =
      (aNODE_t *)((char *)aBASE.base_node + (long)vara->top_node);
    vara++;
  }

  // aNODE  top_arc а֤饢ɥ쥹Ѵ
  for (i=0; i<aBASE.all_node; i++) {
    fc_read(node, sizeof(aNODE_t), fp);
    node->top_arc = (aARC_t *)((char *)aBASE.base_arc + (long)node->top_arc);
    node++;
  }

  // aARC  cond & ptr а֤饢ɥ쥹Ѵ
  for (i=0; i<aBASE.all_arc; i++) {
    fc_read(arc, sizeof(aARC_t), fp);
    arc->cond = FSTRING + (long)arc->cond;
    if (strchr("SGY", arc->type)) {
      arc->ptr = (char *)xBASE.base_vars + (long)arc->ptr;
    }
    else if (arc->type == 'A') {
      arc->ptr = (char *)aBASE.base_vara + (long)arc->ptr;
    }
    arc++;
  }

  vara = aBASE.base_vara;

  for (i=0; i<aBASE.all_vara; i++) {
    node = vara->top_node;
    for (j=0; j<vara->cnt_node; j++) {
      arc  = node->top_arc;
      for (k=0; k<node->cnt_arc; k++) {
	arc->endp = vara->top_node + arc->end;
	arc++;
      }
      node++;
    }
    vara++;
  }

}
//-----------------------------------------------------------------------------
int fc_free_function () {

  free(FSTRING);
  free(xBASE.base_vars);
  free(aBASE.base_vara);
  free(aBASE.base_node);
  free(aBASE.base_arc);
}
/*---------------------------------------------------------------------------*/
xVARS_t *fc_find_xtype (char type, char *name) {

  int       i;
  xVARS_t  *vars = xBASE.base_vars;

  //vs("find xtype %c [%s]\n", type, name);

  for (i=0; i<xBASE.all_vars; i++) {
    if ((type == vars->type) &&
	(strcmp(name, vars->name) == 0))
      return(vars);
    vars++;
  }

  return(NULL);
}
/*---------------------------------------------------------------------------*/
aVARA_t *fc_find_atype (char *name) {

  int       i;
  aVARA_t  *vara = aBASE.base_vara;

  for (i=0; i<aBASE.all_vara; i++) {
    //vs("find vara->name #%02d [%s]\n", i, vara->name);
    if (strcmp(name, vara->name) == 0) return(vara);
    vara++;
  }

  return(NULL);
}
/*-----------------------------------------------------------------------------
  ʸѥե(fp)λꤵ줿(fpos)Υѥ֤
         ( code=0 ʤ顢ѥ󤫤ѥ󥳡ɤ)
-----------------------------------------------------------------------------*/
char *fc_get_original_pattern (FILE *fp, int fpos, int code) {

  static char  pattern[4096], *p1;

  fseek(fp, fpos, SEEK_SET);
  fgets(pattern, 4095, fp);
  pattern[strlen(pattern)-1] = 0;

  if ((code == 0) && (p1 = strchr(pattern, ':')))
    return(p1+1);
  else
    return(&pattern[0]);
}
//-----------------------------------------------------------------------------
int fc_abort (char message[], ...) {

  va_list ap ;

  fflush(stdout);
  fprintf(stdout, "\n");
  
  va_start(ap, message) ;
  vfprintf(stderr, message, ap) ;

  va_end(ap) ;
  exit(-1);
}
//-----------------------------------------------------------------------------
int fc_read (void *addr, int size, FILE *fp) {

  while (size > 1024) {
    fread (addr, 1024, 1, fp);
    addr = (char *)addr + 1024;
    size -= 1024;
  }

  fread (addr, size, 1, fp);
}
//-----------------------------------------------------------------------------
int fc_write (void *addr, int size, FILE *fp) {

  while (size > 1024) {
    fwrite (addr, 1024, 1, fp);
    addr = (char *)addr + 1024;
    size -= 1024;
  }

  fwrite (addr, size, 1, fp);
}
//-----------------------------------------------------------------------------
uchar *fc_short_image (int size, uchar *src) {

  static  uchar image[256];
  uchar   wrk[256], *p1=&wrk[0];
  int     len=0;

  strcpy(wrk, src);

  if (strlen(wrk) <= size) {
    strcpy(image, wrk);
  }
  else {
    while (1) {
      if (*p1 >= 0xa1) {
	if (len + 4 > size) break;
	memcpy(&image[len], p1, 2);
	len += 2;
	p1  += 2;
      }
      else {
	if (len + 3 > size) break;
	image[len++] = *p1++;
      }
    }
    memcpy(&image[len], "", 2);
    image[len+2] = 0;
  }

  return &image[0];
}
//-----------------------------------------------------------------------------
static uchar *fc_substr (uchar *top, uchar *end) {

  static uchar str[4096];

  if (end < top) {
    str[0] = 0;
  }    
  else {
    memcpy(str, top, end-top+1);
    str[end-top+1] = 0;
  }
  return(&str[0]);
}
//-----------------------------------------------------------------------------
uchar *fc_show_image (int size, pFACT_t *fact) {

  static uchar image[256];

  if (fact->vnum > 0)
    sprintf(image, "%s%d", fact->imag, fact->vnum);
  else 
    strcpy(image, fact->imag);

  if (size == 0) return(&image[0]);
  
  return(fc_short_image(size, image));
}
//-----------------------------------------------------------------------------
int fc_display_morp_all () {

  int   i;

  printf("%s  (CNT_MORP=%d)\n\n", JPN_SENTENCE, CNT_MORP);

  for (i=0; i<CNT_MORP; i++) {
    fc_display_morp("", &jBASE[i]);
  }
}
//-----------------------------------------------------------------------------
int fc_display_morp (char *mark, jMORP_t *morp) {

  int   i;
  jINFO_t *info;

  printf("%s%02d %c %-10s", mark, morp->knum-1, morp->flag, morp->tang);
  
  for (i=0; i<morp->cnt_info; i++) {
    info = &morp->info[i];
    printf("  %s %s %s", info->hink, info->nhyo, info->katu);
  }

  printf("\n");
}
//-----------------------------------------------------------------------------
int fc_display_pPATN (char *mark) {

  int    i;

  printf("--------------------------------------------------------------\n");
  printf("pPATN  %s  fact=%d\n\n", mark, PATN->cnt_fact);
  //printf("%s\n\n", fc_get_original_pattern(PATN->fpos, 1));

  // Ǥɽ
  for (i=0; i<PATN->cnt_fact; i++) {
    fc_display_pFACT(PATN->top_fact + i);
  } 
}
//-----------------------------------------------------------------------------
int fc_display_pFACT (pFACT_t *fact) {

  int      i;
  gFUNC_t *pg;

  printf("#%02d %c %d z=%d s=%d-%d ",
	fact->num, fact->type, fact->mode, fact->zmac, fact->snum, fact->styp);

  if (fact->gobi) printf("g=%d", fact->gobi->gc);

  printf(" %-6s", fc_show_image(0, fact));

  if (fact->gobi) {
    pg = fact->gobi;
    for (i=0; i<pg->gc; i++) {
      printf(" %s %x", pg->name[i], pg->ptr[i]);
    }
  }

  if (fact->imiz) fc_display_pIMIZ(fact->imiz);
  if (fact->end) printf(" top=#%02d end=#%02d", fact->top, fact->end);

  printf("\n");
}
//-----------------------------------------------------------------------------
int fc_display_pIMIZ (pIMIZ_t *imiz) {

  int     i;

  //printf("<fc_display_pIMIZ>");
  for (i=0; i<imiz->NIc; i++) {
    printf(" NI:"); if (imiz->NIm[i]) printf(" - ");
    printf("%d-%d", imiz->NIx[i], imiz->NIy[i]);
  }
  for (i=0; i<imiz->NKc; i++) {
    printf(" NK:"); if (imiz->NKm[i]) printf(" - ");
    printf("%d-%d", imiz->NKx[i], imiz->NKy[i]);
  }
  for (i=0; i<imiz->NYc; i++) {
    printf(" NY:"); if (imiz->NYm[i]) printf(" - ");
    printf("%d-%d", imiz->NYx[i], imiz->NYy[i]);
  }
  for (i=0; i<imiz->KRc; i++) {
    printf(" KR:%s", imiz->KR[i]);
  }
}
//-----------------------------------------------------------------------------
int fc_display_pMATON (uchar *maton) {

  int      i;
  uchar   *p1;
  pFACT_t *fact;

  for (p1=maton; *p1!=0; p1+=3) {
    i = atoi(fc_substr(p1+1, p1+2));
    fact = PATN->top_fact + i;
    if (p1 != maton) printf(" ");
    printf("%s", fact->imag);
    if (fact->vnum) printf("%d", fact->vnum);
  }
  printf("\n");
}
//-----------------------------------------------------------------------------
int fc_display_pNODE (int vflg) {

  int      i;
  char     stack[4096]="";
  pNODE_t *px;

  printf("----------------------------------------------------------------\n");

  if (PATN->cnt_arc == 1) {
    sprintf(stack, "*%02d", 1);
    fc_display_pNODE_sub(vflg, PATN->arcp.node, stack);
  }
  else {
    for (i=0; i<PATN->cnt_arc; i++) {
      px = *(PATN->arcp.list + i);
      sprintf(stack, "*%02d", i+1);
      fc_display_pNODE_sub(vflg, px, stack);
    }
  }
}
//-----------------------------------------------------------------------------
int fc_display_pNODE_sub (int vflg, pNODE_t *node, char *p_stack) {

  int  i;
  char  stack[4096];
  pNODE_t *px;

  if (vflg && node->vsym) {
    sprintf(stack, "%s %s($%d-%d)", p_stack, fc_show_image(0, node->fact),
	    node->vsym, node->vseq);
  }
  else {
    sprintf(stack, "%s %s", p_stack, fc_show_image(0, node->fact));
  }

  if (node->cnt_arc == 0) {
    printf("%s\n", stack);
    return 0;
  }

  if (node->cnt_arc == 1) {
    fc_display_pNODE_sub(vflg, node->arcn.node, stack);
  }
  else {
    for (i=0; i<node->cnt_arc; i++) {
      px = *(node->arcn.list + i);
      fc_display_pNODE_sub(vflg, px, stack);
    }
  }
}
/*-----------------------------------------------------------------------------
  ؿλ̥ޥåɽ
-----------------------------------------------------------------------------*/
int fc_show_yoso_jmap () {

  xVARS_t *vars = xBASE.base_vars;
  xJMAP_t *jmap;

  int    i, j, cc;

  for (i=0; i<xBASE.all_vars; i++) {
    if ((vars->type == 'Y') &&
	(jmap = vars->jmap)) {
      vs("\n ==== YOSO JMAP [%s] cc=%d\n", vars->name, jmap->cc);
      for (cc=0; cc<jmap->cc; cc++) {
	for (j=0; j<jmap->mc[cc]; j++) {
	  vs("  %d", jmap->map[cc][j]);
	}
	vs("\n");
      }
    }
    vars++;
  }
}
//-----------------------------------------------------------------------------
int fs_abort (char message[], ...) {

  va_list ap;

  fprintf(stderr, ";;; ERROR %s : ", SERV_WHO);
  va_start(ap, message);
  vfprintf(stderr, message, ap);
  va_end(ap);
  fprintf(stderr, "\n");
  fflush(stderr);
  exit(-1);
}
//-----------------------------------------------------------------------------
char *fs_hostname () {

  static  char  hostname[MAXHOSTNAMELEN+1];

  if (gethostname(hostname, MAXHOSTNAMELEN) == -1) fs_abort("gethostname");

  return &hostname[0];
}
/*-----------------------------------------------------------------------------
  Ф³
-----------------------------------------------------------------------------*/
int  fs_connect (int port) {

  static  int  sd;

  struct  hostent     *hp;
  struct  sockaddr_in  server;

  if (! (hp = gethostbyname(fs_hostname()))) fs_abort("gethostbyname");

  bzero((char *)&server,sizeof(server));
  server.sin_family = AF_INET;
  bcopy(hp->h_addr,&server.sin_addr,hp->h_length);
  server.sin_port = htons(port);

  if ((sd = socket(AF_INET,SOCK_STREAM,0)) == -1) fs_abort("socket");

  if (connect(sd,(struct sockaddr *)&server,sizeof(server)) == -1) {
    if (close(sd) == -1) fs_abort("close");
    return(-1);
  }

  return(sd);
}
//-----------------------------------------------------------------------------
int  fs_send (int sd, char *msg) {

  int   rc;
  char  tmp[SERV_MSGLEN];

  sprintf(tmp, "%s%s%s", SERV_TOP, msg, SERV_END);

  if ((rc = send(sd, tmp, strlen(tmp), 0)) == -1) fs_abort("send");
}
//-----------------------------------------------------------------------------
int  fs_recv (int sd, char *msg) {

  int    len;
  char   tmp[SERV_MSGLEN];

  *msg = 0;

  while (1) {
    if ((len = recv(sd, tmp, SERV_MSGLEN, 0)) == -1) fs_abort("recv");
    if (len > 0) {
      tmp[len] = 0;
      strcat(msg, tmp);
      if ((strlen(msg) > (SERV_TOPLEN + SERV_ENDLEN)) &&
	  (memcmp(msg, SERV_TOP, SERV_TOPLEN) == 0)   &&
	  (memcmp(msg+strlen(msg)-SERV_ENDLEN, SERV_END, SERV_ENDLEN) == 0))
	break;
    }
  }

  // Ƭ SERV_TOP   SERV_END 
  strcpy(msg, msg+SERV_TOPLEN);
  *(msg+strlen(msg)-SERV_ENDLEN) = 0;

  return 1;
}
//-----------------------------------------------------------------------------
