/*-----------------------------------------------------------------------------
  ʸѥޥåפκ
-----------------------------------------------------------------------------*/

#include "common.h"
#include "aisystem.h"

#define OUTPUT_MESSAGE 1

#define MAX_TOKEN      256
#define MAX_VSYM        16   // ֲѻ국λѲ(1ѥ󤢤)
#define MAX_ZNODE   4096 * 2

#define MAX_NI        2715
#define MAX_NK         126
#define MAX_NY          36

// ʸѥ (ù)

typedef struct zFACT  zFACT_t;
typedef struct zATTR  zATTR_t;
typedef struct zMATN  zMATN_t;
typedef struct zNODE  zNODE_t;

//-----------------------------------------------------------------------------
struct zATTR {  // å°
  char   nin_nest;       // [...] ͥȿ
  char   nin_grup[256];  //       롼ֹ
  char   nin_type;       //       ʬ(1=Ƭ, 0=¾)

  char   sen_grup;       // (...) 롼ֹ
  char   sen_type;       //       ʬ(1/2/3)

  char   goj_grup;       // {...} 롼ֹ
  char   goj_type;       //       ʬ(1/2/3)
};
//----------------------------------------------------------------------------
struct zFACT {  // ѥ
  char     num;        // ֹ
  char     type;       // S A G Y J # Z M V v / !  | , [ ] ( ) { }      (*1)
  char     mode;       // 0=ȹ 1=ɬ 2=Ǥ 3= (*2)
  uchar    imag[256];  // ѥΥ᡼ (ѿ/ؿ̾, , )
  char     vnum;       // ѿֹ  type=S or A Τ
  char     imiz[4096]; // ̣°  type=S or A Τ
  char     zmac;
  char     vsym;       // Ѱֵ $n  n
  char     top;        // Ƭֹ (*3)
  char     end;        // ǽֹ (*4)
  void    *ptr;        // ѿ/ؿΰݥ (*4)
  zATTR_t  attr;       // å°
  char     gc;                  // ѿ˽°ؿο
  char     gnam[MAX_FUNCG][256]; //              ؿ̾
  xVARS_t *gptr[MAX_FUNCG];      //              ؿΰݥ
};
//----------------------------------------------------------------------------
struct {  // ʸѥ
  int      fpos;             // ʸѥեа (fseekǻ)

  int      fc;               // Ǥο
  zFACT_t  fact[256];        // 

  int      mc;         // ȥޥȥθĿ
  char     matn[4096][512];  // ȥޥȥ

} ZPTN;
//----------------------------------------------------------------------------
struct zMATN {  // ȥޥȥ
  int    qnum;
  char  *matn;       // ZPTN.matn[x]
  char   newm[512];

  short  fnum;   // ΰפ zMATN[n]
  short  flen;   // ΰפĹ
  short  fset;   // ϿlinkΥǥå

  short  rnum;   // ΰפ zMATN[n]
  short  rlen;   // ΰפĹ
  short  rpos;   // פƬ (ʬ)
  short  ryou;   // פƬ ()
  short  rdel;   // 1=Ĵä줿

  short  link;       // linkƤ  
  short  ldel[4096]; //                   1=ä
  short  lnum[4096]; //                   ZMATNΰ    zMATN[lnum]
  short  lpos[4096]; //                   matn  ΰ   zMATN[me][lpos]
  short  lbak[4096]; //                   ˵ zMATN[lnum][lbak]
};
//----------------------------------------------------------------------------
struct zNODE {  // Ρ
  int      numb;    // Ρֹ
  int      zn  ;    // ZMATN[zn]
  int      pos ;    // ZMATN[zn].newm[pos] = cnn
  int      top ;    // 1=ƬΡ 9=jumpΡ   (ȤPATN)
  int      fnum;    // PATN->fact[fnum]
  char     vsym;   // ֲѵ ($n  n)
  char     vseq;   // ֲѵ ($n  ư)
  int      ac  ;    // ʬ
  int      azn [4096];    // ʬzn
  int      apos[4096];    // ʬpos
  int      anum[4096];    // ʬΥΡֹ
};
//----------------------------------------------------------------------------
// Хѿ

pBASE_t   PBASE;               // ѥܾ
uchar     PTN_ID[MAX_PTNID];   // ѥID
uchar     PTN_IMAG[4096];      // ѥϥ᡼
int       PTN_LINE;            // ѥϹֹ
int       INP_PATN=0;          // ѥ
int       ERR_PATN=0;          // 顼ѥ
int       CNT_GENPERM;         // ȹ礻
int       GENPERM[4096];       // ȹ礻
int       SER_NODE;            // ѥΡɰϢֹ

short     NI_CODE[MAX_NI];  // ̣° NI : ޤ祳
short     NK_CODE[MAX_NK];  // ̣° NK : ޤ祳
char      NY_CODE[MAX_NY];  // ̣° NK : ޤ祳

aiDes_t   KRDIC_DES;        // 켭(aisam)ǥץ
FILE     *PFILE;            // ѥեǥץ

char      BLANK[512];

int  QC, NQC;
char QUE [4096][512];
char NEWQ[4096][512];
char NEWV[4096][MAX_VSYM];     //  $n  n   VINF[que][vsym] ư

// QUE[]ΰֲѻ국ξ (stage05_1reset, stage05_5Ǻ)
char   VC  [4096];             //  
char   VINF[4096][MAX_VSYM];   //  $n  n   VINF[que][vsym] ư


int      ZC;
zMATN_t  ZMATN[4096];

int ZNC;
zNODE_t  ZNODE[MAX_ZNODE];

int JNC;
int JN_ZN [4096];
int JN_POS[4096];
int JN_NUM[4096];

int NODE_SEQ = 0;

// ؿץȥ
int      f_analyze   (uchar*, int);

int      f_stage01   (uchar*);
int      f_stage01_1 (uchar*, uchar[], uchar[][4096]);
int      f_stage01_2 (uchar*, zFACT_t[]);
int      f_stage01_3 (int, zFACT_t[], uchar[][4096]);
int      f_stage02   ();
int      f_stage03   ();
int      f_stage04   ();
int      f_stage05   ();
int      f_stage05_1 (char[]);
int      f_stage05_2 ();
int      f_stage05_3 ();
int      f_stage05_4 ();
int      f_stage05_5 ();
int      f_stage05_6 ();
int      f_stage06   ();
int      f_stage07   ();
int      f_stage07_1 (char*, char[]);
int      f_stage08   ();
int      f_stage08_1 ();
int      f_stage08_2 ();
int      f_stage08_3 ();
int      f_stage09   ();
int      f_stage10   ();
int      f_stage10_1 ();
int      f_stage10_2 ();
int      f_stage10_3 ();
int      f_stage11   ();

uchar   *f_store_PSTRING (uchar*);
pIMIZ_t *f_store_CATEGORY (pIMIZ_t*);
gFUNC_t *f_store_FUNCG (char, char[][256], xVARS_t*[]);

int      f_output (FILE *, char[6][256]);
int      f_output_ARCLIST (FILE*);

int      f_usage (char*);
int      f_set_argument (int, char*[], char[6][256]);
int      f_error (int, char[], ...);

int      f_split (uchar*, uchar, uchar[][512]);
int      f_gen_perm (int);
int      f_gen_perm_sub(int[], int, int, int, int[]);
int      f_setup_imizokusei (FILE *);
int      f_check_imizokusei (char *);
int      f_edit_imizokusei  (zFACT_t*, pFACT_t*);

uchar   *f_find_close_kakko (char, char, uchar*);
uchar   *f_show_image (int, zFACT_t*);
char    *f_maton_image (uchar*);

int      f_display_all ();
int      f_display_automaton (char*, uchar*);
int      f_display_zPATN (char*);
int      f_display_zFACT (zFACT_t);
int      f_display_linkage ();
int      f_display_linkage_sub (int, char*, char*);
int      f_display_zNODE ();

/*-----------------------------------------------------------------------------
  ʸѥեιʸ

  S/Aѿ  Xn :  X=ʸ[] n=[]
  ؿ     ^x :  x=Ѿʸ[]
  ؿ     .x :  x=Ѿʸ[]

   /        Υ          / or /xxx
       !        ʸᶭ국
       [...]    Ǥǵ      [...] or #[...] or #n[...]
       <...>    䴰ǵ      <...> or #<...> or #n<...>
       (...)    򵭹      (...)Ǥ | Ƕڤ
       {...}    Ǥջ국  {...} or #{...} or #n{...}
                                  {...}Ǥ , Ƕڤ
       $n^{...} ֲѻ국  $n ѥʣս˸
       #(...)
       #ޥؿ̾(...)

    

      #[...]  # ̵뤹
      #<...>  # ̵뤹
      #{...}  # ̵뤹
      #n<...> ν #n[...] Ʊ
      (...)  ηϰ̣°ȤƤȤ
      $n^{...}  ^ ϸؿλϤޤȤƤȤ

      ͥȴط :  = A  B ϴޤޤ

               B [...]  B <...>  B (...)  B {...}
     ---------+-----------------------------------
      A [...] |                         
      A <...> |                         
      A (...) |                         
      A {...} |                         

-----------------------------------------------------------------------------*/
/*  N9(N1|N2)V5(N6|N7)

   0. N9  N1  V5  N6 
   1. N9  N1  V5  N7 
   2. N9  N2  V5  N6 
   3. N9  N2  V5  N7 

 0. N9  N1  V5  N6  

                        ʬ     
      1. N7   lnum( 1) lpos(15) lbak(18)
      2. N2   lnum( 2) lpos( 3) lbak( 6)
      3. N2   lnum( 3) lpos( 3) lbak( 6)

   --- 
  ....     N9  N1  V5  N6  
   --- 

 1. N9  N1  V5  N7  

    0. N9  N1  V5    fnum( 0) flen(18)
  ....     N7  <                  A09   >
    0.    rnum( 0) rlen( 3) rpos(21) ryou(21)

 2. N9  N2  V5  N6  

    0. N9    fnum( 0) flen( 6)
  ....     N2   <      A04J05            >
    0. V5  N6    rnum( 0) rlen(12) rpos(12) ryou(12)

 3. N9  N2  V5  N7  

    0. N9    fnum( 0) flen( 6)
  ....     N2  V5  N7  <      A04J05A06J07A09   >
    0.    rnum( 0) rlen( 3) rpos(21) ryou(21)

*/
/*  (*1) type
          S  : Sѿ             #  : ϰϻ국
          A  : Aѿ             Z  : ̴ؿ
          G  : ؿ            M  : ޥؿ
          Y  : ؿ            V  : ֲѵ 
          J  :                 v  : ֲѵ 
          /  : Υ            |  : Υǥߥå  (xxx|xxx)
          !  : ʸᶭ국    ,  : ǤջΥǥߥå  {xxx,xxx}

          [] : Ǥǵ  *** Τ <> ξ⤢ (imag=<...>)
          () : 򵭹
          {} : Ǥջ국

    (*2) ǤǤ mode=2
    (*3) #n礹, ̴ؿ礹, ޥؿ礹
    (*4) type = S G Y ΤȤ xvars ؤ,  type = A / ΤȤ aVARA ؤ
*/
//-----------------------------------------------------------------------------
int main (int argc, char *argv[]) {

  uchar buf[4096],*p1;
  FILE  *fp, *fpz, *outfp;
  int    fpos, i;
  char   lines[10];
  char   args[6][256];

  f_set_argument(argc, argv, args);

  //open ʸѥ
  if ((PFILE = fopen(args[1], "r")) == NULL)
    fc_abort(";;; ERROR: file open  ʸѥ '%s'\n", args[1]);

  // open ̣°ꥹ
  if ((fpz = fopen(args[4], "r")) == NULL)
    fc_abort(";;; ERROR: file open  ̣°ꥹ '%s'\n", args[4]);

  // open 켭
  if ((KRDIC_DES=aiOpnIsam(args[5],AI_RO)) == NULL)
    fc_abort(";;; ERROR: file open '%s'\n;;; aiOpnIsam , aistatus [%d]\n",
	     args[5], aistatus);

  // open ϥޥå
  if ((outfp = fopen(args[2], "w")) == NULL)
    fc_abort(";;; ERROR: file open ϥޥå '%s'\n", args[2]);

  // ѥեιԿ
  sprintf(buf, "wc -l %s", args[1]);

  if (! (fp = popen(buf,"r")))
    strcpy(lines, "?");
  else {
    fgets (buf, 80 ,fp);
    i = atoi(buf);
    sprintf(lines, "%d", i);
    pclose (fp );
  }

  fprintf(stderr, "\nʸѥ     %-20s  %s lines\n", args[1], lines);
  fprintf(stderr, "ޥå       %s\n",   args[2]);
  fprintf(stderr, "ѿ/ؿޥå  %s\n",   args[3]);
  fprintf(stderr, "̣°   %s\n",   args[4]);
  fprintf(stderr, "켭         %s\n\n", args[5]);

  memset(BLANK, ' ', sizeof(BLANK));

  // ̣°ꥹȤŸ
  f_setup_imizokusei(fpz);

  // ʸΰγ
  PSTRING = (uchar *)fc_alloc("PSTRING", 1, MAX_PSTRING);

  // ̣°ΰγ
  CATEGORIES =
    (pIMIZ_t *)fc_alloc("CATEGORIES", MAX_IMIZ_ALL, sizeof(pIMIZ_t));

  // ARCLISTΰγ
  ARCLIST = (pNODE_t **)fc_alloc("ARCLIST", 1, MAX_ARCLIST);

  // °ؿΰγ
  FUNCG = (gFUNC_t *)fc_alloc("gFUNC", MAX_FUNCG_ALL, sizeof(gFUNC_t));

  // ؿ/ѿޥåפΥ
  fc_load_function(args[3]);

  // ѥν
  memset(&PBASE, 0x00, sizeof(PBASE));

  PBASE.base_patn = (pPATN_t *)fc_alloc("pPATN", MAX_PATN, sizeof(pPATN_t));
  PBASE.base_fact = (pFACT_t *)fc_alloc("pFACT", MAX_FACT, sizeof(pFACT_t));
  PBASE.base_node = 
    (pNODE_t *)fc_alloc("pNODE", MAX_NODE_ALL, sizeof(pNODE_t));

  PTN_LINE = 0;

  while (1) {
    fpos = ftell(PFILE);
    if (fgets(buf, 4095, PFILE) == NULL) break;
    PTN_LINE++;
    if (! (PTN_LINE % 1000)) {
      fprintf(stderr, "%6d / %s\n", PTN_LINE, lines);
      fflush(stderr);
    }

    buf[strlen(buf)-1] = 0;

    if (buf[0] == ';') continue;   // comment out pattern
    if (buf[0] == 0)   continue;   //  null line

    // ѥIDȥѥʸʬ
    if ((p1 = strchr(buf, ':')) == NULL) {
      PTN_ID[0] = 0;
      strcpy(PTN_IMAG, buf);
      f_error(1, "η顼");
    }
    else {
      *(p1) = 0;
      if (strlen(buf) > (MAX_PTNID - 1))
	f_error(2, "ѥIDηС");
      strcpy(PTN_ID, buf);     // ѥID
      strcpy(PTN_IMAG,  p1+1); // ѥϥ᡼ (for error message)
      strcpy(buf, p1+1);       // ѥϥ᡼ (for parse)
      f_analyze(buf, fpos);    // ʸ
      INP_PATN++;
    }
  }

  fclose(PFILE);
  aiClsIsam(KRDIC_DES);

  // ѥ󡦥ޥåפν
  f_output(outfp, args);

  fc_free_function();
  free(PSTRING);
  free(CATEGORIES);
  free(ARCLIST);
  free(FUNCG);
  free(PBASE.base_patn);
  free(PBASE.base_fact);
  free(PBASE.base_node);

  fprintf(stderr, ";;; finished\n");

#ifdef OUTPUT_MESSAGE
  fprintf(stderr, "\npattern  : input  %8d\n",   INP_PATN);
  fprintf(stderr, "           error  %8d\n",   ERR_PATN);
  fprintf(stderr, "           normal %8d\n",   PBASE.all_patn);
  fprintf(stderr, "           factor %8d\n",   PBASE.all_fact);
  fprintf(stderr, "           node   %8d\n\n", PBASE.all_node);

  fprintf(stderr, "PSTRING  : size   %8d\n",   LEN_PSTRING);
  fprintf(stderr, "           words  %8d\n\n", CNT_PWORDS);

  fprintf(stderr, "CATEGORY : size   %8d\n",   CNT_CATEGORY * sizeof(pIMIZ_t));
  fprintf(stderr, "           count  %8d\n\n", CNT_CATEGORY);

  fprintf(stderr, "NODE     : size   %8d\n", PBASE.all_node * sizeof(pNODE_t));
  fprintf(stderr, "           count  %8d\n\n", PBASE.all_node);

  fprintf(stderr, "ARCLIST  : size   %8d\n", CNT_ARCLIST * sizeof(pNODE_t **));
  fprintf(stderr, "           count  %8d\n\n", CNT_ARCLIST);

  fprintf(stderr, "FUNCG    : size   %8d\n",   CNT_FUNCG * sizeof(gFUNC_t));
  fprintf(stderr, "           words  %8d\n\n", CNT_FUNCG);

  fprintf(stderr, ";;; Writing pattern data\n\n");
#endif
}
/*-----------------------------------------------------------------------------
  ѥʸ

  stage01 : ѥ
  stage02 : åΥ󥿥åå
  stage03 : ͥȾκǤΥ롼ײ
  stage04 : ɬܻ̥ޥåפκ                  === pending ===
  stage05 : ȥޥȥκ
  stage06 : κ
  stage07 : פǤκ
  stage08 : ȥޥȥΰ
  stage09 : ZPTN  pPATN
  stage10: Ρ
  stage11: ̴ؿ
-----------------------------------------------------------------------------*/
int f_analyze (uchar *src, int fpos) {

  memset(&ZPTN, 0x00, sizeof(ZPTN));

  ZPTN.fpos = fpos;

  if (! f_stage01(src)) return 0;  // ѥ
  if (! f_stage02())    return 0;  // åå

  f_stage03();  // ͥȾκǤΥ롼ײ
  f_stage05();  // ȥޥȥκ
  f_stage06();  // κ

  //  ZPTN ΥåǤ(=)

  f_stage07();  // פǤκ
  f_stage08();  // ȥޥȥΰ
  f_stage09();  // ZPTN  pPATN
  f_stage10();  // Ρ
  f_stage11();  // ̴ؿ

  //vs("\n%s\n", PTN_IMAG);
  //fc_display_pPATN("");
}
/*-----------------------------------------------------------------------------
  stage01 : ѥ
-----------------------------------------------------------------------------*/
int f_stage01 (uchar *src) {

  int     i, j, fc, gc;
  uchar   buf[4096];
  uchar   imi[MAX_TOKEN][4096];
  zFACT_t fact[256];

  // ܥåỌ̇̄°γΥ
  if (! f_stage01_1(src, buf, imi)) return 0;

  // ѥʸ老ȤˤޤȤ
  memset(&fact[0], 0x00, sizeof(fact));
  fc = f_stage01_2(buf, fact);

  // ʤɤط
  if (! f_stage01_3(fc, fact, imi)) return 0;

  /*------------------------------------------------------------------
     fact[]פǤ type='x' ȤʤäƤ

    'x' fact[]ͤˤ
  --------------------------------------------------------------------*/
  j = 0;

  for (i=0; i<fc; i++) {
    if (fact[i].type != 'x') {  // ͭ
      if (i != j)
	memcpy(&fact[j], &fact[i], sizeof(zFACT_t));
      j++;
    }
  }

  fc = j;

  // ؿ (ľѿ/ؿ˥Хɤ)
  j = -1;
  for (i=0; i<fc; i++) {
    switch (fact[i].type) {
    case 'S': // Sѿ
    case 'Y': // ؿ
    case 'A': // Aѿ
      j = i;
      break;
    case 'G': // ؿ
      if (j == -1)
	return(f_error(116, "ؿλ̵֤ '%s'",
		       fact[i].imag));

      gc = fact[j].gc;  // ߤν°

      if (gc == MAX_FUNCG)
	return(f_error(116, "ؿλ꤬¿᤮ '%s'",
		       fact[i].imag));

      strcpy(&fact[j].gnam[gc][0], &fact[i].imag[1]); // '^' ΤƤ
      fact[j].gptr[gc] = (xVARS_t *)fact[i].ptr;
      fact[j].gc++;
      fact[i].type = 'x';  // θؿǤΤƤ
      break;
    default:
      j = -1;
    }
  }

  /*------------------------------------------------------------------
     fact[]θؿǤ type='x' ȤʤäƤ

    'x' ZPTN.fact[]˥ԡ
  --------------------------------------------------------------------*/

  ZPTN.fc = 0;

  for (i=0; i<fc; i++) {

    if (fact[i].type != 'x') {  // ͭ
      memcpy(&ZPTN.fact[ZPTN.fc], &fact[i], sizeof(zFACT_t));
      ZPTN.fact[ZPTN.fc].num  = ZPTN.fc++;
    }
  }

  return (ZPTN.fc);
}
/*-----------------------------------------------------------------------------
  stage01_1 : ܥåỌ̇̄°γΥ                      ѥ
-----------------------------------------------------------------------------*/
int f_stage01_1 (uchar *src, uchar buf[], uchar imi[][4096]) {

  uchar  *p1, *p2, *p3, wrk[4096];
  int    ic=0;

  // Υå
  if (strstr(src, "[]") ||
      strstr(src, "<>") ||
      strstr(src, "()") ||
      strstr(src, "{}"))
    return(f_error(801, "(ʸ̵)Υå"));

  if (strstr(src, "||"))
      return(f_error(802, "(||)"));

  if (strstr(src, ",,"))
      return(f_error(803, "θǤ(,,)"));

  // ǻѤü쵭椬ȤƤʤå
  if (strchr(src, '&')) return(f_error(100, "̤Τε '&'"));
  if (strchr(src, '+')) return(f_error(101, "̤Τε '+'"));

  strcpy(buf, src);
  p1 = &buf[0];

  // ̣°γΥ
  p1 = &buf[0];
  while (p2 = strchr(p1, '(')) {
    if (! (p3 = f_find_close_kakko('(', ')', p2)))
      return(f_error(102, "åԴ"));
    if ((memcmp(p2+1, "NI:", 3) == 0) ||
	(memcmp(p2+1, "NY:", 3) == 0) ||
	(memcmp(p2+1, "NK:", 3) == 0) ||
	(memcmp(p2+1, "KR:", 3) == 0)) {
      strcpy(imi[ic++], fc_substr(p2+1, p3-1));
      *p2 = 0;
      sprintf(wrk, "%s&%02d%s", buf, ic-1, p3+1);
      strcpy(buf, wrk);
    }
    p1 = p2+1;
  }

  return 1;
}
/*-----------------------------------------------------------------------------
  stage01_2 : 1. ѥʸ老ȤˤޤȤ                    ѥ
             2. <...>  [...] ѹ
-----------------------------------------------------------------------------*/
int f_stage01_2 (uchar *buf, zFACT_t fact[]) {

  uchar  *p1;
  int    i, b, fc=0;

  // 1. ѥʸ老ȤˤޤȤ
  for (p1=buf; *p1!=0; p1++) {
    // (1) type μ
    b = fc - 1;
    if      (isdigit(*p1)) fact[fc].type = 'N';   // 
    else if (isupper(*p1)) fact[fc].type = 'A';   // ʸ
    else if (islower(*p1)) fact[fc].type = 'a';   // Ѿʸ
    else if (*p1 >= 0xa1)  fact[fc].type = 'Z';   // 
    else if (*p1 == '_')   fact[fc].type = 'a';   // Ѿʸ
    else {
      fact[fc].type = *p1;   // 
      b = -1;  // (3)ǥХɤʤ褦
    }

    // (2) imag γǼ
    fact[fc].imag[0] = *p1;

    // (3) ľƱtypeʤľ˥Хɤ()
    if ((b >= 0) && (fact[b].type == fact[fc].type)) {
      strcat(fact[b].imag, fact[fc].imag);
    }
    else {
      fc++;
    }
  }

  /*-----------------------------------------------------------
    2. <...>  [...] ѹ
         Ǽ̤Ǥ褦, imag  '<...>' Ĥ
  ------------------------------------------------------------*/
  for (i=0; i<fc; i++) {
    if (fact[i].type == '<') {
      fact[i].type = '[';
      strcpy(fact[i].imag, "<...>");
    }
    else if (fact[i].type == '>') {
      fact[i].type = ']';
      strcpy(fact[i].imag, "<...>");
    }
  }

  return fc;
}
/*-----------------------------------------------------------------------------
  stage01_3 : ʤɤط                             ѥ

      1. '/case' ʤɤΥ
      2. #n[...] ʤɤ '#'
      3. ѿ̾ѿֹ, ̣°ΥХ
      4. . ȸؿ̾ΥХ
      5. ^ ؿ̾ΥХ
-----------------------------------------------------------------------------*/
int f_stage01_3 (int fc, zFACT_t fact[], uchar imi[][4096]) {

  int    i, n;
  char   next;

  for (i=0; i<fc; i++) {
    n = i + 1;                    // tokenΥǥå
    next = fact[n].type;          // tokenλ

    switch (fact[i].type) {

    case '/':
      // 
      if (strchr("Na", next)) {  // '/2' '/case' etc.,
	strcat(fact[i].imag, fact[n].imag);  // '/case'
	fact[n].type = 'x';  // '2' 'case' etc., ΤƤ
      }
      // '/0'  '/' ѹ
      if (strcmp(fact[i].imag, "/0") == 0) strcpy(fact[i].imag, "/");
      if (! (fact[i].ptr = fc_find_atype(fact[i].imag)))
	return(f_error(113, "̤ΤΥ '%s'", fact[i].imag));
      break;

    case '#': // #n[...] #n<...> #n{...} #̴ؿ̾(...) #ޥؿ̾(...)

      switch (next) {
      case 'N':  // #n...
	strcat(fact[i].imag, fact[n].imag);  // 'n' 򥳥ԡ
	fact[n].type = 'x';  // 'n'ΤƤ
	break;

      case '[': // #[...]
      case '{': // #{...}
	fact[i].type = 'x';  //  # ϼΤƤ
	break;

            	// i  next    
      case 'Z': // #̴ؿ̾(...)
	if (fact[n+1].type != '(')
	  return(f_error(103, "ΰ̣(1) '#'"));
	fact[i].type = 'Z';  // ʬ '#'  'Z' 
	strcpy(fact[i].imag, fact[n].imag);
	fact[n].type = 'x';  // ̤ ä
	break;

      case 'A': // #ޥؿ̾
	if (fact[n+1].type == 'N') {
	  strcat(fact[n].imag, fact[n+1].imag);  // 'ؿ̾'
	  fact[n+1].type = 'x';  // ΤƤ
	  if (fact[n+2].type != '(')
	    return(f_error(104, "ΰ̣(2) '#'"));
	}
	else {
	  if (fact[n+1].type != '(')
	    return(f_error(105, "ΰ̣(2) '#'"));
	}
	fact[i].type = 'x';  // ʬ(#)Ͼä
	fact[n].type = 'M';  // next(A) 'M' ѹ
	break;
      default:
	return(f_error(106, "ΰ̣(3) '#'"));
      }
      break;  // end of case '#'

    case '^':
      if (fact[n].type != 'a') return(f_error(107, "ΰ̣(4) '^'"));
      if (! (fact[i].ptr = fc_find_xtype('G', fact[n].imag)))
	return(f_error(118, "̤Τθؿ̾ '%s'", fact[n].imag));
      strcat(fact[i].imag, fact[n].imag);  // ^meirei
      fact[i].type = 'G';  // ʬ 'G' 
      fact[n].type = 'x';  // next(a)ϼΤƤ
      break;

    case '.':
      if (fact[n].type != 'a') return(f_error(109, "ΰ̣(4) '.'"));
      if (! (fact[i].ptr = fc_find_xtype('Y', fact[n].imag)))
	return(f_error(110, "̤Τؿ̾ '%s'", fact[n].imag));
      strcat(fact[i].imag, fact[n].imag);  // .kako
      fact[i].type = 'Y';  // ʬ 'Y' 
      fact[n].type = 'x';  // next(a)ϼΤƤ
      break;

    case '$':  // $n^{...} or $n
      if ((fact[i+1].type == 'N') &&
	  (fact[i+2].type == '^') &&
	  (fact[i+3].type == '{')) {
	strcat(fact[i].imag, fact[n].imag); // 'n'Х
	fact[i+1].type = 'x';  // N ΤƤ
	fact[i+2].type = 'x';  // ^ ΤƤ
	fact[i].type   = 'V';  // ʬ
      }
      else if ((fact[i+1].type == 'N') &&
	       (fact[i+2].type != '^')) {
	strcat(fact[i].imag, fact[n].imag); // 'n'Х
	fact[i+1].type = 'x';  // N ΤƤ
	fact[i].type   = 'v';  // ʬ
      }
      else
	return(f_error(111, "ΰ̣(5) '$'"));
      break;	

    case 'Z': //  (=)
      fact[i].type = 'J';  // ʬ 'J' 
      break;

    case 'A': // ʸ (=ѿ̾)

      if (fact[n].type != 'N') return(f_error(112, "ѿֹ椬ʤ #%02d", i));
      if (fact[i].ptr = (fc_find_xtype('S', fact[i].imag))) {
	fact[i].type = 'S';
      }
      else if (fact[i].ptr = fc_find_atype(fact[i].imag)) {
	fact[i].type = 'A';
      }
      else return(f_error(113, "̤Τѿ̾ '%s'", fact[i].imag));
      if (atoi(fact[n].imag) > 127)
	f_error(114, "ѿֹ Ͱ襨顼 '%s'", fact[n].imag);
      fact[i].vnum = atoi(fact[n].imag); // ѿֹ
      fact[n].type = 'x';  // next(N)ϼΤƤ

      if ((fact[n+1].type == '&') &&   // ̣°
	  (fact[n+2].type == 'N')) {
	strcpy(fact[i].imiz, imi[atoi(fact[n+2].imag)]);
	fact[n+1].type = 'x';  // & ϼΤƤ
	fact[n+2].type = 'x';  // n ϼΤƤ
      }

      break;

    default:
      if (! strchr("xM,|![](){}", fact[i].type))
	return(f_error(115, "stage01 ̤Τtype #%02d '%c'",
		       i, fact[i].type));

    } // end of switch (fact[i].type)

  } // end of for (i=0; i<fc; i++)
}
/*-----------------------------------------------------------------------------
  stage02 : åΥ󥿥åå
-----------------------------------------------------------------------------*/
int f_stage02 () {

  int   i, kn=0, hn=0, mn=0, on=0;    // kn=[] hn=<> mn=() on={}

  for (i=0; i<ZPTN.fc; i++) {

    switch (ZPTN.fact[i].type) {

    case '[':
      //if (kn > 0) return(f_error(201, "[...] ͥȤƤ"));
      if (hn > 0) return(f_error(202, "<...> '[' "));
      if (mn > 0) return(f_error(203, "(...) '[' "));
      //if (on > 0) return(f_error(204, "{...} '[' "));
      kn++; break;

    case '<':
      //if (kn > 0) return(f_error(211, "[...] '<' "));
      if (hn > 0) return(f_error(212, "<...> ͥȤƤ"));
      if (mn > 0) return(f_error(213, "(...) '<' "));
      //if (on > 0) return(f_error(214, "{...} '<' ");
      hn++; break;

    case '(':
      //if (kn > 0) return(f_error(221, "[...] '(' "));
      if (hn > 0) return(f_error(222, "<...> '(' "));
      if (mn > 0) return(f_error(223, "(...) ͥȤƤ"));
      //if (on > 0) return(f_error(224, "{...} '(' "));
      mn++; break;

    case '{':
      if (kn > 0) return(f_error(231, "[...] '{' "));
      if (hn > 0) return(f_error(232, "<...> '{' "));
      if (mn > 0) return(f_error(233, "(...) '{' "));
      if (on > 0) return(f_error(234, "{...} ͥȤƤ"));
      on++; break;

    case ']':
      if (kn == 0) return(f_error(241, " ']' "));
      kn--;
      break;

    case '>':
      if (hn == 0) return(f_error(242, " '>' "));
      hn--;
      break;

    case ')':
      if (mn == 0) return(f_error(243, " ')' "));
      mn--;
      break;

    case '}':
      if (on == 0) return(f_error(244, " '}' "));
      on--;
      break;

    }
  }

  if (kn > 0) return(f_error(251, "'[' ĤƤʤ"));
  if (hn > 0) return(f_error(252, "'<' ĤƤʤ"));
  if (mn > 0) return(f_error(253, "'(' ĤƤʤ"));
  if (on > 0) return(f_error(254, "'{' ĤƤʤ"));

  return 1; // no error
}
/*-----------------------------------------------------------------------------
  stage03 : ͥȾκǤΥ롼ײ
-----------------------------------------------------------------------------*/
int f_stage03 () {

  int      i, nc=0, sc=0, gc=0;
  zFACT_t *fact;
  zATTR_t  tmp;

  memset(&tmp, 0x00, sizeof(zATTR_t));

  /* n=ͥȿ  g[n]=롼ֹ
     nin_type ǤǶʬ     1=Ƭ 0=¾
     sen_type Ƕʬ     1=1 2=2 3=3 (*1)
     goj_type ǤǶʬ 1=1 2=2 3=3 (*1)

     (*1) ( N1   | xxx | x.xxx )
            |  |     |     | |
	    1  3     2     2 3

	    㤨 "V5.kako" ʤ V5=Ƭ(1/2), .kako=¾(3)Ȥʤ
  */

  for (i=0; i<ZPTN.fc; i++) {
    fact = &ZPTN.fact[i];

    if (strchr("[({", fact->type)) {
      switch (fact->type) {
      case '[':
	tmp.nin_nest++;
	tmp.nin_grup[tmp.nin_nest-1] = ++nc; break;
      case '(': tmp.sen_grup = ++sc; break;
      case '{': tmp.goj_grup = ++gc; break;
      }
      memcpy(&fact->attr, &tmp, sizeof(zATTR_t));
      //vs("%s  %d %d\n", fact->imag, tmp.sen_grup, tmp.sen_type);
      switch (fact->type) {
      case '[': tmp.nin_type = 1; break;
      case '(': tmp.sen_type = 1; break;
      case '{': tmp.goj_type = 1; break;
      }
    }
    else if (strchr("])}", fact->type)) {
      switch (fact->type) {
      case ']': tmp.nin_type = 0;break;
      case ')': tmp.sen_type = 0;break;
      case '}': tmp.goj_type = 0;break;
      }
      memcpy(&fact->attr, &tmp, sizeof(zATTR_t));
      //vs("%s  %d %d\n", fact->imag, tmp.sen_grup, tmp.sen_type);
      switch (fact->type) {
      case ']': tmp.nin_nest--; break;
      case ')': tmp.sen_grup = 0;break;
      case '}': tmp.goj_grup = 0;break;
      }
    }
    else {
      if (fact->type == ',') 	tmp.goj_type = 0;
      memcpy(&fact->attr, &tmp, sizeof(zATTR_t));
      //vs("%s  %d %d\n", fact->imag, tmp.sen_grup, tmp.sen_type);
      if (strchr("SAGYJ/!", fact->type)) { // ȹ
	tmp.nin_type = 0;
	if (tmp.sen_type > 0) tmp.sen_type = 3;
	if (tmp.goj_type > 0) tmp.goj_type = 3;
      }
      else if (fact->type == '|') {
	tmp.sen_type = 2;
      }
      else if (fact->type == ',') {
	tmp.goj_type = 2;
      }
    }
  }

  // ƾȹǤ mode 򥻥åȤ

  for (i=0; i<ZPTN.fc; i++) {
    fact = &ZPTN.fact[i];
    if (strchr("SAGYJ/!", fact->type)) { // ȹ
      if (fact->attr.nin_nest > 0) {
	fact->mode = 2;   // Ǥ
      }
      else if (fact->attr.sen_grup > 0) {
	fact->mode = 3;   // 
      }
      else {
	fact->mode = 1;   // ɬ
      }
    }
  }

  //f_display_zPATN("stage03");

  return 1;
}
/*-----------------------------------------------------------------------------
  stage04 : ɬܻ̥ޥåפκ
-----------------------------------------------------------------------------*/
int f_stage04 () {

  int      i;
  uchar    jsent[4096]="";   // Ǥλ
  uchar    jhiss[4096]="";   // ɬǤλ

  // ѥλ̤ PSTRING ˤ(ͽ)
  // ؿλ̤ FSTRING ˤ
  //   ,ݥ󥿤ǲФ褤...Ǥ˲Ƥ
  //    xSTRING бӥåȥޥåפ
  //   ѥ󤴤Ȥ˻ʤƤ褤



  // ǥ롼 or =  񤷤
  // äؿ   or =  񤷤

  for (i=0; i<ZPTN.fc; i++) {

    if (ZPTN.fact[i].type == 'J') { // 
      switch (ZPTN.fact[i].mode) {
      case 1: //ɬ
	strcat(jhiss, ZPTN.fact[i].imag);
	break;
      case 3: // 
	strcat(jsent, ZPTN.fact[i].imag);
      }
    }
  }
}
/*-----------------------------------------------------------------------------
  stage05 : ȥޥȥκ
-----------------------------------------------------------------------------*/
int f_stage05 () {

  int     done;
  uchar  *p1;

  // ١
  f_stage05_1(QUE[0]);
  QC = 1;

  // ܤΰư֤ݤĤֲѻ국 $n^{...} ˽
  while (p1 = strchr(QUE[0], 'V')) {
    f_stage05_2();
  }

  do {
    done = 0;
    for (p1=QUE[0]; *p1!=0; p1+=3) {
      switch (*p1) {
      case '(': // 򵭹 (...|...|...)
	f_stage05_3(); done = 1; break;
      case '[': // Ǥǵ  [...]
	f_stage05_4(); done = 1; break;
      case '{': // Ǥջ국  {...}
	f_stage05_5(); done = 1; break;
      }
      if (done) break;
    }
  } while (done);

  f_stage05_6(); // que[i] ȹפǤ  ZPTN.matn[]

  return 1;
}
/*-----------------------------------------------------------------------------
  stage05_1 : ١κ                                 ȥޥȥ
-----------------------------------------------------------------------------*/
int f_stage05_1 (char base[]) {

  int     i;
  char    *p1;

  // base = cnn ¤  c= nn=ֹ

  p1 =&base[0];

  for (i=0; i<ZPTN.fc; i++) {
    if (! strchr("#ZM", ZPTN.fact[i].type)) {
      sprintf(p1, "%c%02d", ZPTN.fact[i].type, i);
      p1 += 3;
    }
  }

  *p1 = 0;

  // reset: QUE[]ΰֲѻ국ξ
  memset(VC, 0x00, 4096);

  return 1;
}
/*-----------------------------------------------------------------------------
  stage05_2 : ֲѻ국 $n^{...}                      ȥޥȥ
-----------------------------------------------------------------------------*/
int f_stage05_2 () {

  int      i, j, k, n;
  uchar    wrk0[4096], wrk1[4096], wrk2[4096], wrk3[4096];
  uchar    wrk4[4096], wrk5[4096];
  uchar    *p1, *p2;
  zFACT_t *vf1, *vf2;
  int      vpos[512];

  // QUE[]Τ٤Ƥ NEWQ[]

  NQC = 0;

  for (i=0; i<QC; i++) {

    strcpy(wrk0, QUE[i]);

    p1 = strchr(wrk0, 'V');

    j = atoi(fc_substr(p1+1, p1+2));  // ѥֹ
    vf1 = &ZPTN.fact[j];

    p2  = strchr(p1+3, '}');

    strcpy(wrk1, fc_substr(wrk0, p1-1));   // xxx${...}zzz xxx
    strcpy(wrk2, fc_substr(p1+6, p2-1));   // xxx${...}zzz ...
    strcpy(wrk3, p2+3);                    // xxx${...}zzz zzz
    /*
    f_display_zPATN("stage05_2");

    vx("wrk0 [%s]\n", wrk0);
    vx("wrk1 [%s]\n", wrk1);
    vx("wrk2 [%s]\n", wrk2);
    vx("wrk3 [%s]\n", wrk3);
    */
    // wrk0 = xxxvzzz  *** ʬ⻲ʬѤ
    sprintf(wrk0, "%sv%s%s", wrk1, fc_substr(p1+1, p1+2), wrk3);

    // wrk0 γ뻲ʬ 'v'  '&' Ѥ
    //   k   Хɥ쥹  vpos[]
    k = 0;
    for (p1=&wrk0[0]; *p1!=0; p1+=3) {
      if (*p1 == 'v') {
	j = atoi(fc_substr(p1+1, p1+2));  // ѥֹ
	vf2 = &ZPTN.fact[j];
	if (strcmp(vf1->imag, vf2->imag) == 0) {  // Ʊ $n 
	  *p1 = '&';
	  vpos[k++] = p1 - &wrk0[0];
	}
      }
    }

    if (k < 2) f_error(501, "ֲѻ국 '%s' ̵̣", vf1->imag);

    // QUE[i]  k θĿ䤹

    for (j=0; j<k; j++) {
      strcpy(wrk4, wrk0);
      wrk4[vpos[j]] = '+';  // ŬѤս '&'  '+'
      // ŬѤʤս &nn 
      while (p1 = strchr(wrk4, '&')) strcpy(p1, p1+3);
      // ŬѤս '+'  {...}Ȥִ
      p1 = strchr(wrk4, '+');
      sprintf(wrk5, "%s%s%s", fc_substr(wrk4, p1-1), wrk2, p1+3);


      n = atoi(&vf1->imag[1]);  // $n^{...}  n

      // i = QUE[i]
      // n = $n^{...}  n
      // j =  $n νи

      VINF[i][n] = j;
      memcpy(NEWV[NQC], VINF[i], MAX_VSYM);

      strcpy(NEWQ[NQC++], wrk5);
    }
  }

  // NEWQ[0]  QUE[0],  NEWV[0]  VINF[0]
  QC = 1;
  strcpy(QUE[0], NEWQ[0]);
  memcpy(VINF[0], NEWV[0], MAX_VSYM);

  // NEWQ[1]ʹ  QUE[1]ʹ ᤹ : ʣ򤱤
  for (i=1; i<NQC; i++) {
    for (j=0; j<QC; j++) {
      if (strcmp(NEWQ[i], QUE[j]) == 0) break; //ʣ
    }
    if (j == QC) {
      memcpy(VINF[QC], NEWV[i], MAX_VSYM);
      strcpy(QUE[QC++], NEWQ[i]);
    }
  }
}
/*-----------------------------------------------------------------------------
  stage05_3 : 򵭹 (...|...|...)                      ȥޥȥ
-----------------------------------------------------------------------------*/
int f_stage05_3 () {

  int      i, j, sc;
  uchar    wrk1[4096], wrk2[4096], wrk3[4096];
  uchar    *p1, *p2;
  uchar    split[512][512];

  // QUE[]Τ٤Ƥ NEWQ[]
  NQC = 0;
  for (i=0; i<QC; i++) {
    if (p1 = strchr(QUE[i], '(')) {
      p2 = f_find_close_kakko('(', ')', p1);
      strcpy(wrk1, fc_substr(QUE[i], p1-1));  // (...) 
      strcpy(wrk2, fc_substr(p1+3, p2-1));    // (...) 
      strcpy(wrk3, p2+3);                     // (...) θ
      p1 = p2 + 3;
      sc = f_split(wrk2, '|', split);
      for (j=0; j<sc; j++) {
	sprintf(wrk2, "%s%s%s", wrk1, split[j], wrk3);
	memcpy(NEWV[NQC], VINF[i], MAX_VSYM);
	strcpy(NEWQ[NQC++], wrk2);
      }
    }
    else {
      strcpy(NEWQ[NQC++], QUE[i]);
    }
  }
  memcpy(QUE [0], NEWQ[0], NQC * 512);
  memcpy(VINF[0], NEWV[0], NQC * MAX_VSYM);
  QC = NQC;
}
/*-----------------------------------------------------------------------------
  stage05_4 : Ǥǵ  [...]                          ȥޥȥ
-----------------------------------------------------------------------------*/
int f_stage05_4 () {

  int      i;
  uchar    wrk1[4096], wrk2[4096], wrk3[4096];
  uchar    *p1, *p2;

  // que[]Τ٤Ƥ NEWQ[]
  NQC = 0;
  for (i=0; i<QC; i++) {
    if (p1 = strchr(QUE[i], '[')) {
      p2 = f_find_close_kakko('[', ']', p1);
      strcpy(wrk1, fc_substr(QUE[i], p1-1));  // [...] 
      strcpy(wrk2, fc_substr(p1+3, p2-1));    // [...] 
      strcpy(wrk3, p2+3);                     // [...] θ
      p1 = p2 + 3;
      sprintf(NEWQ[NQC++], "%s%s%s", wrk1, wrk2, wrk3);
      sprintf(NEWQ[NQC++], "%s%s",   wrk1,       wrk3);
    }
    else {  // [...]̵ʤä
      strcpy(NEWQ[NQC++], QUE[i]);
    }
  }

  // NEWQ[]  QUE[] ᤹
  memcpy(QUE[0], NEWQ[0], NQC * 512);
  QC = NQC;
}
/*-----------------------------------------------------------------------------
  stage05_5 : Ǥջ국  {...}                      ȥޥȥ
-----------------------------------------------------------------------------*/
int f_stage05_5 () {

  int      i, j, sc;
  uchar    wrk1[4096], wrk2[4096], wrk3[4096];
  uchar    *p1, *p2;
  uchar    split[512][512];

  // QUE[]Τ٤Ƥ NEWQ[]
  NQC = 0;
  for (i=0; i<QC; i++) {
    p1 = strchr(QUE[i], '{');
    p2 = strchr(p1+1, '}');
    strcpy(wrk1, fc_substr(QUE[i], p1-1));  // {...} 
    strcpy(wrk2, fc_substr(p1+3, p2-1));    // {...} 
    strcpy(wrk3, p2+3);                     // {...} θ
    p1 = p2 + 3;
    sc = f_split(wrk2, ',', split);
    CNT_GENPERM = 0;    // ȹ礻
    f_gen_perm(sc);     // ȹ礻
    
    strcpy(wrk2, wrk1);  // {...} 

    for (j=0; j<CNT_GENPERM; j++) {
      if (GENPERM[j] == -1) {
	strcat(wrk2, wrk3);
	memcpy(NEWV[NQC], VINF[i], MAX_VSYM);
	strcpy(NEWQ[NQC++], wrk2);
	strcpy(wrk2, wrk1);  // {...} 
      }
      else {
	strcat(wrk2, split[GENPERM[j]-1]);
      }
    }
  }
  // NEWQ[]  QUE[] ᤹
  memcpy(QUE [0], NEWQ[0], NQC * 512);
  memcpy(VINF[0], NEWV[0], NQC * MAX_VSYM);
  QC = NQC;
}
/*-----------------------------------------------------------------------------
  stage05_6 : QUE ȹפǤ  ZPTN        ȥޥȥ
-----------------------------------------------------------------------------*/
int f_stage05_6 () {

  int      i, j, k;
  char     wrk[4096], bef[256], now[256];
  uchar   *p1;
  zFACT_t *fact;

  for (i=0; i<QC; i++) {
    wrk[0] = bef[0] = j = 0;

    for (p1=QUE[i]; *p1!=0; p1+=3) {

      k = atoi(fc_substr(p1+1, p1+2));  // ֹ
      fact = &ZPTN.fact[k];             // 
 
      if (fact->mode) {  // ȹ˻Ѥ
	strcpy(now, f_show_image(0, fact));

	if (strchr("/!", fact->type)) {
	  if (strcmp(bef, now) != 0) {
	    memcpy(&wrk[j], p1, 3);
	    j += 3;
	  }
	}
	else {
	  memcpy(&wrk[j], p1, 3);
	  j += 3;
	}
	strcpy(bef, now);
      }
    }
    wrk[j] = 0;
    strcpy(ZPTN.matn[i], wrk);
  }
  
  ZPTN.mc = QC;
}
/*-----------------------------------------------------------------------------
  stage06 : κ
-----------------------------------------------------------------------------*/
int f_stage06 () {
  
  int   i, j, v;
  char  close;

  // #n , $n, ̴ؿ('Z'), ޥؿ('M')礹Ǥ
  // Ƭȹֹ  top
  // ǽȹֹ  end

  for (i=0; i<ZPTN.fc; i++) {
    if (strchr("#VZM", ZPTN.fact[i].type)) {
      switch (ZPTN.fact[i+1].type) {
      case '[': close = ']'; break;
      case '(': close = ')'; break;
      case '{': close = '}'; break;
      default:
	return(f_error(601, "ͽʤ '%c'", ZPTN.fact[i+1].type));
      }
      for (j=i+2; j<ZPTN.fc; j++) {
	if (ZPTN.fact[j].type == close) break;   // åĤ
	if (ZPTN.fact[j].mode) {
	  if (ZPTN.fact[i].top == 0) ZPTN.fact[i].top = j;
	  ZPTN.fact[i].end = j;
	}
      }
      if (j == ZPTN.fc)
	return(f_error(688, "ץ Х"));
    }
  }

  // Ǥ vsym
  for (i=0; i<ZPTN.fc; i++) {
    if (strchr("V", ZPTN.fact[i].type)) {
      v = atoi(&ZPTN.fact[i].imag[1]);  // $n  n
      for (j=0; j<ZPTN.fc; j++) {
	if ((ZPTN.fact[j].num >= ZPTN.fact[i].top) &&
	    (ZPTN.fact[j].num <= ZPTN.fact[i].end)) {
	  ZPTN.fact[j].vsym = v;  // ƬǤOK
	  break;
	}
      }
    }
  }

  return 1;
}
/*-----------------------------------------------------------------------------
  stage07 : פǤκ

      1. ȹǤˡ#ZM ֤
      2. åࡢV ϼΤƤ
      3. ȥޥȥ(ZPTN.matn)Ʊ
-----------------------------------------------------------------------------*/
int f_stage07 () {

  int      i, n=0;
  char     old_new[512];  // ֹε쿷оɽ
  zFACT_t  new_fact[256];

  for (i=0; i<ZPTN.fc; i++) {
    if (ZPTN.fact[i].mode) { // ȹ
      memcpy(&new_fact[n], &ZPTN.fact[i], sizeof(zFACT_t));  // old  new_fact
      new_fact[n].num = n;
      old_new[ZPTN.fact[i].num] = n++; // ֹε쿷оɽ
    }
  }

  for (i=0; i<ZPTN.fc; i++) {
    if (strchr("#ZM", ZPTN.fact[i].type)) {  // ϰϻ, ̴ؿ, ޥؿ
      memcpy(&new_fact[n], &ZPTN.fact[i], sizeof(zFACT_t));  // old  new_fact
      new_fact[n].num = n;
      old_new[ZPTN.fact[i].num] = n++; // ֹε쿷оɽ
    }
  }

  ZPTN.fc = n;                                             // ǿ
  memcpy(&ZPTN.fact[0], &new_fact[0], sizeof(new_fact));   // 

  // '#' ϰϻ국, 'Z' ̴ؿ, 'M' ޥؿ
  // 嵭Ǥ top, end Ѥ

  for (i=0; i<ZPTN.fc; i++) {
    if (strchr("#ZM", ZPTN.fact[i].type)) {
      ZPTN.fact[i].top = old_new[ZPTN.fact[i].top];
      ZPTN.fact[i].end = old_new[ZPTN.fact[i].end];
    }
  }

  // ȥޥȥ󤫤פǤ,ֹѤ

  for (i=0; i<ZPTN.mc; i++) {
    f_stage07_1(ZPTN.matn[i], old_new);
  }

  return 1;
}
//-----------------------------------------------------------------------------
int f_stage07_1 (char *matn, char old_new[]) {

  int      num;
  char    *p1, wrk[10], new_matn[512]="";
  zFACT_t *fact;  

  for (p1=matn; *p1!=0; p1+=3) {
    num = atoi(fc_substr(p1+1, p1+2));
    fact = &ZPTN.fact[num];
    if (fact->mode ||                 // ȹ
	strchr("#ZM", fact->type)) {  // ϰϻ, ̴ؿ, ޥؿ
      sprintf(wrk, "%c%02d", *p1, old_new[num]);
      strcat(new_matn, wrk);
    }
  }

  strcpy(matn, new_matn);
}
/*-----------------------------------------------------------------------------
  stage08 : ȥޥȥΰ  (ZMATNκ)
-----------------------------------------------------------------------------*/
int f_stage08 () {

  int     i;

  // ȥޥȥ(ZPTN.matn) ZMATN Ͽ
  ZC = ZPTN.mc;
  memset(ZMATN, 0x00, ZC * sizeof(zMATN_t));

  for (i=0; i<ZC; i++) {
    ZMATN[i].qnum = i;
    ZMATN[i].matn = ZPTN.matn[i];
    strcpy(ZMATN[i].newm, ZPTN.matn[i]);
  }

  f_stage08_1(); // פlink
  f_stage08_2(); // פjump
  f_stage08_3(); // linkκĴ
}
/*-----------------------------------------------------------------------------
  פlink
-----------------------------------------------------------------------------*/
int f_stage08_1 () {

  int     hit, lenB, lenF, a, b, c;
  char   *B;

  for (b=1; b<ZC; b++) {

    B    = ZMATN[b].matn;
    lenB = strlen(B);

    if (ZMATN[b].rlen == lenB) continue;  // Τ

    hit = 0;

    for (lenF=lenB; lenF>0; lenF-=3) {  // B ʡ,û

      for (a=0; a<b; a++) {

	if (a == b) continue;

	if (memcmp(B, ZMATN[a].newm, lenF) == 0) { // פ
	  ZMATN[b].fnum = a;
	  ZMATN[b].flen = lenF;
	  memset(ZMATN[b].newm, ' ', lenF);

	  c = ZMATN[a].link;
	  ZMATN[b].fset = c;

	  ZMATN[a].lnum[c] = b;
	  ZMATN[a].lpos[c] = lenF - 3;
	  ZMATN[a].lbak[c] = lenF;
	  ZMATN[a].link++;
	  hit = 1;
	  break;
	}
      }
      if (hit) break;
    }
  }
}
/*-----------------------------------------------------------------------------
  פjump
-----------------------------------------------------------------------------*/
int f_stage08_2 () {

  int      hit, lenA, lenB, lenR, a, b, fnum, fset;
  char    *B, *A, *pb;
  zMATN_t *X;

  for (b=1; b<ZC; b++) {

    B    = ZMATN[b].matn;
    lenB = strlen(B);

    if (lenB == ZMATN[b].flen) continue;  // ΰ

    hit = 0;

    for (pb=B; *pb!=0; pb+=3) { // B ʡ,û

      lenR = strlen(pb);

      for (a=0; a<b; a++) {

	if (a == b) continue;

	A    = ZMATN[a].newm;
	lenA = strlen(A);

	if ((lenA >= lenR) &&
	    (memcmp(A+lenA-lenR, pb, lenR) == 0)) {  // 
	  ZMATN[b].rnum = a;
	  ZMATN[b].rlen = lenR;
	  ZMATN[b].rpos = lenB - lenR;
	  ZMATN[b].ryou = lenA - lenR;

	  if ((lenR == lenB) &&  // ΰ : פä
	      (ZMATN[b].flen)) {

	    fnum = ZMATN[b].fnum;
	    fset = ZMATN[b].fset;
	    X = &ZMATN[fnum];
	    X->ldel[fset] = 1;
	    ZMATN[b].fnum = 0;
	    ZMATN[b].flen = 0;
	  }
	  memset(&ZMATN[b].newm[ZMATN[b].rpos], ' ', lenR);
	  hit = 1;
	  break;
	}
      }
      if (hit) break;
    }
  }
}
/*-----------------------------------------------------------------------------
  linkκĴ
-----------------------------------------------------------------------------*/
int f_stage08_3 () {

  int      i, j, k;
  zMATN_t *zm, *xm;

  for (i=0; i<ZC; i++) {
    zm  = &ZMATN[i];
    if (zm->rlen == 0) continue;
    
    /* 1. ʬ rlen ˵äƤõ
         xm->lnum[k] == i
	 xm->lbak[k] == zm->rpos

       2. ؤε,ʬѹ
         xm->lnum[k] = zm->rnum
	 xm->lbak[k] = strlen(xm->matn) - zm->rlen
   */

    for (j=0; j<ZC; j++) {
      xm  = &ZMATN[j];
      for (k=0; k<xm->link; k++) {
	if ((xm->lnum[k] == i) &&
	    (xm->lbak[k] == zm->rpos)) {  // ʬ˵ȤƤݥ
	  xm->lnum[k] = zm->rnum;
	  xm->lbak[k] = strlen(xm->matn) - zm->rlen;
	  zm->rdel = 1; // ʬä
	}
      }
    }
  }
}
/*-----------------------------------------------------------------------------
  stage09 : ZPTN  pPATN
-----------------------------------------------------------------------------*/
int f_stage09 () {

  int      i;
  pFACT_t *pf;
  zFACT_t *zf;

  // pPATN 򣱸ڤФ
  PATN = PBASE.base_patn + PBASE.all_patn++;
  PATN->fpos     = ZPTN.fpos;
  PATN->cnt_fact = ZPTN.fc;
  PATN->top_fact = PBASE.base_fact + PBASE.all_fact;

  for (i=0; i<ZPTN.fc; i++) {
    zf = &ZPTN.fact[i];

    //if (zf->type == 'V') continue;

    // pFACT 򣱸ڤФ
    pf = PBASE.base_fact + PBASE.all_fact++;
    pf->num  = zf->num;
    pf->type = zf->type;
    pf->mode = zf->mode;
    pf->vnum = zf->vnum;
    pf->zmac = zf->zmac;
    pf->top  = zf->top;
    pf->end  = zf->end;
    pf->snum = zf->attr.sen_grup;
    pf->styp = zf->attr.sen_type;

    // imag 
    pf->imag = f_store_PSTRING(zf->imag);

    // imiz 
    if (zf->imiz[0] != 0) {
      if (! f_edit_imizokusei(&ZPTN.fact[i], pf)) return 0;
    }

    // ptr 
    pf->ptr = zf->ptr;

    // gobi
    if (zf->gc) {
      pf->gobi = f_store_FUNCG(zf->gc, zf->gnam, zf->gptr);
    }
  }

  return 1;
}
/*-----------------------------------------------------------------------------
  stage10 : Ρɤ
-----------------------------------------------------------------------------*/
int f_stage10 () {

  f_stage10_1();  // ΡɡꥹȤκ ZMATN[]  ZNODE[]
  f_stage10_2();  // ΡɡꥹȤΥ֥
  f_stage10_3();  // Ρɤ
}
/*-----------------------------------------------------------------------------
  stage10_1 : ΡɡꥹȤκ

    ZMATN ΥΡɤɬפȤ륢ƥ(*1)ΥꥹȤ

       (*1) ZMATNlink/jumpƤʤƥ

         ZC        ZNC         JNC
       ZMATN[]  ZNODE[] or JN_xx[]
       zMATN_t    zNODE_t    ¤
-----------------------------------------------------------------------------*/
int f_stage10_1 () {

  int      zn, i, pos, top, done;
  zMATN_t *zm;
  char    *p1;
  zNODE_t *np;

  ZNC = JNC = 0;

  for (zn=0; zn<ZC; zn++) {
    zm  = &ZMATN[zn];
    top = done = 0;

    // ʬ
    p1  = zm->matn + zm->flen;  // ʬľ
    pos = zm->flen;             // ʬľ

    for (; *p1!=0; p1+=3, pos+=3) {  // ƥƥ

      if (zm->rlen && (pos == zm->rpos)) break;  // ʬ

      if (ZNC == MAX_ZNODE)
	fc_abort(";;; ERROR: exceed size MAX_ZNODE\n");

      done = 1;
      np   = &ZNODE[ZNC++];
      memset(np, 0x00, sizeof(zNODE_t));
      np->numb = ZNC - 1;
      np->zn   = zn;
      np->pos  = pos;

      if (top == 0) {
	if (! zm->flen) top = np->top = 1;      // ƬΡ
      }

      i = atoi(fc_substr(p1+1, p1+2));
      np->fnum = i;                   // ֹ (PATN->fact[])

      if (ZPTN.fact[i].vsym) {
	char vn = ZPTN.fact[i].vsym;
	np->vsym = vn;             // $n^{...}  n
	np->vseq = VINF[zn][vn];   // n ΰư
      }

      // ʬ
      np->ac = 0;  // reset ʬ

      // ľΥƥؤʬ
      if ((*(p1+3) != 0) && (pos+3 != zm->rpos)) {
	np->azn [0] = zn;
	np->apos[0] = pos + 3;
	np->ac      = 1;
      }

      // linkص뤿ʬ
      for (i=0; i<zm->link; i++) {
	if ((zm->ldel[i] ==  0) &&
	    (pos == zm->lpos[i])) {
	  np->azn [np->ac] = zm->lnum[i];  // zn
	  np->apos[np->ac] = zm->lbak[i];  // pos
	  np->ac++;
	}
      }
    }

    // פΥΡɽ
    if ((zm->rdel == 0) && (zm->rlen)) {
      if (done == 0) {

	if (! zm->flen) {
	  JN_ZN [JNC] = zm->rnum;  // zn
	  JN_POS[JNC] = zm->ryou;  // pos
	  JNC++;
	}
	else {
	  if (ZNC == MAX_ZNODE)
	    fc_abort(";;; ERROR: exceed size MAX_ZNODE\n");
	  np = &ZNODE[ZNC++];
	  memset(np, 0x00, sizeof(zNODE_t));
	  np->numb = ZNC - 1;
	  np->zn   = zn;
	  np->pos  = 0;
	  np->azn [0] = zm->rnum;  // zn
	  np->apos[0] = zm->ryou;  // pos
	  np->ac = 1;
	}

      }
      else {
	np->azn [np->ac] = zm->rnum;  // zn
	np->apos[np->ac] = zm->ryou;  // pos
	np->ac++;
      }
    }
  }
}
/*-----------------------------------------------------------------------------
  stage10_2 : ΡɡꥹȤΥ֥
-----------------------------------------------------------------------------*/
int f_stage10_2 () {

  int      i, j, k;
  zNODE_t *np, *xp;

  if (PBASE.all_node > MAX_NODE_ALL)
    fc_abort(";;; ERROR: exceed size MAX_NODE_ALL\n");

  // ֥
  for (i=0; i<ZNC; i++) {
    np = &ZNODE[i];

    for (j=0; j<np->ac; j++) {  // ʬ

      for (k=0; k<ZNC; k++) {

	xp = &ZNODE[k];

	if ((np->azn [j] == xp->zn) &&    // azn []: ʬ zn
	    (np->apos[j] == xp->pos)) {   // apos[]:                pos
	  np->anum[j] = xp->numb;         // anum[]:         Ρֹ
	  break;
	}
      }
      if (k == ZNC) {
	fflush(stdout);
	fprintf(stderr, ";;; ERROR can't assemble\n\n");
	fprintf(stderr, "  ZNODE #%d  azn=%d apos=%d\n",
		np->numb, np->azn[j], np->apos[j]);
	exit(0);
      }
    }
  }

  for (i=0; i<JNC; i++) {

    for (k=0; k<ZNC; k++) {

      xp = &ZNODE[k];

      if ((JN_ZN [i] == xp->zn) &&    // azn []: ʬ zn
	  (JN_POS[i] == xp->pos)) {   // apos[]:                pos
	JN_NUM[i] = xp->numb;         // anum[]:         Ρֹ
	break;
      }
    }
    if (k == ZNC) {
      fflush(stdout);
      fprintf(stderr, ";;; ERROR can't assemble\n\n");
      fprintf(stderr, "  JN #%d  ZN=%d POS=%d\n",
	      i, JN_ZN[i], JN_POS[i]);
      exit(0);
    }
  }
}
/*-----------------------------------------------------------------------------
  stage10_3 : Ρɤ   ZNODE[]  pNODE[]
-----------------------------------------------------------------------------*/
int f_stage10_3 () {

  int      i, j, ac=0;
  pNODE_t *node, *arcp[4096], *arcn[4096], **ptr, *base_node;
  zNODE_t *zp;

  base_node = PBASE.base_node + PBASE.all_node;

  // Ρɤ
  for (i=0; i<ZNC; i++) {
    zp = &ZNODE[i];
    node = base_node + zp->numb;
    node->nseq = zp->numb;
    node->fact = PATN->top_fact + zp->fnum;
    node->vsym = zp->vsym;
    node->vseq = zp->vseq;

    node->cnt_arc = zp->ac;

    for (j=0; j<zp->ac; j++) {
      arcn[j] = base_node + zp->anum[j];
    }

    if (zp->ac == 1) {
      node->arcn.node = arcn[0];
    }
    else if (zp->ac > 1) {

      if (CNT_ARCLIST + zp->ac > MAX_ARCLIST)
	fc_abort(";;; ERROR: exceed size MAX_ARCLIST\n");

      ptr = ARCLIST + CNT_ARCLIST;
    
      memcpy(ARCLIST+CNT_ARCLIST, arcn, sizeof(pNODE_t *) * zp->ac);
      CNT_ARCLIST += zp->ac;
      node->arcn.list = ptr;
    }

    if (zp->top) {
      arcp [ac++] = node;
    }
  }

  PATN->cnt_arc = ac;

  for (i=0; i<JNC; i++) {
    arcp[ac++] = base_node + JN_NUM[i];
    PATN->cnt_arc++;
  }

  PBASE.all_node += ZNC;

  if (ac < 2) {
    PATN->arcp.node = arcp[0];
  }
  else {
    if (CNT_ARCLIST + ac > MAX_ARCLIST)
      fc_abort(";;; ERROR: exceed size MAX_ARCLIST\n");

    ptr = ARCLIST + CNT_ARCLIST;
    
    memcpy(ARCLIST+CNT_ARCLIST, arcp, sizeof(pNODE_t *) * ac);
    CNT_ARCLIST += ac;

    PATN->arcp.list = ptr;
  }
}
/*-----------------------------------------------------------------------------
  stage11 : ̴ؿ

     ѥǤ zmac ꤹ
-----------------------------------------------------------------------------*/
int f_stage11 () {

  int  i, j;
  pFACT_t *pz;

  for (i=0; i<PATN->cnt_fact; i++) {
    pz = PATN->top_fact + i;
    if (pz->type == 'Z') {
      for (j=pz->top; j<=pz->end; j++) {
	(PATN->top_fact + j)->zmac = i;
      }
    }
  }
}
/*-----------------------------------------------------------------------------
  ʸ word  PSTRING ¸ߤ뤫Ĵ١
  ¸ߤСΥɥ쥹֤
  ¸ߤʤСword ʸ PSTRING ɲäơΥɥ쥹֤
-----------------------------------------------------------------------------*/
uchar *f_store_PSTRING (uchar *word) {

  int     i;
  static uchar  *str;

  str = PSTRING;

  for (i=0; i<CNT_PWORDS; i++) {
    fflush(stdout);
    if (strcmp(word, str) == 0) return str;
    str += LEN_PWORDS[i] + 1;
  }

  //           0123456789
  //  len=3    abc0def0xyz
  //               |   |
  //               |   str(4+3+1)=8
  //              str(4)
  //
  // word ̤Ͽñ, str ɲä٤PSTRINGΥɥ쥹ؤƤ

  if ((LEN_PSTRING + strlen(word) + 1) > MAX_PSTRING)
    fc_abort(";;; ERROR: exceed size PSTRING\n");

  LEN_PSTRING += strlen(word) + 1;
  LEN_PWORDS[CNT_PWORDS++] = strlen(word);
  strcpy(str, word);

  return str;
}
/*-----------------------------------------------------------------------------
  ̣°Ͽ
    new ƱΥǡ CATEGORIES ˤ,Υɥ쥹֤
    ʤ CATEGORIES ɲä,Υɥ쥹֤
-----------------------------------------------------------------------------*/
pIMIZ_t *f_store_CATEGORY (pIMIZ_t *new) {

  static pIMIZ_t *old;
  int     i;

  old = CATEGORIES;

  for (i=0; i<CNT_CATEGORY; i++) {
    if (memcmp(old, new, sizeof(pIMIZ_t)) == 0) return(old);
    old++;
  }

  // newface
  memcpy(old, new, sizeof(pIMIZ_t));
  CNT_CATEGORY++;
  return(old);
}
//-----------------------------------------------------------------------------
gFUNC_t *f_store_FUNCG (char gc, char gnam[][256], xVARS_t *gptr[]) {

  gFUNC_t *pg;
  int      i, j;

  pg = FUNCG;

  for (i=0; i<CNT_FUNCG; i++) {
    if (pg->gc == gc) {
      for (j=0; j<gc; j++) {
	if (strcmp(pg->name[j], &gnam[j][0]) != 0) break;
      }
      if (j == gc) return (pg); // Ʊ
    }
    pg++;
  }

  // ̤Ͽξ

  pg->gc = gc;
  for (i=0; i<gc; i++) {
    pg->name[i] = gptr[i]->name;
  }
  memcpy(&pg->ptr[0], &gptr[0], sizeof(xVARS_t *) * gc);

  CNT_FUNCG++;

  return(pg);
}
/*-----------------------------------------------------------------------------
  ѥ󡦥ޥåפե˽Ϥ
-----------------------------------------------------------------------------*/
int f_output (  FILE  *fp, char args[6][256]) {

  // ʸѥե̾ν
  fprintf(fp, "%s\n", args[1]);

  // ؿޥåץե̾ν
  fprintf(fp, "%s\n", args[3]);

  // ɬܻ̥ޥåפɬ̷׻
  f_check_jmap();

  // PBASEν
  PBASE.arclist    = ARCLIST;
  PBASE.pstring    = PSTRING;
  PBASE.fstring    = FSTRING;
  PBASE.categories = CATEGORIES;
  PBASE.funcg      = FUNCG;
  fc_write(&PBASE, sizeof(PBASE), fp);

  // PSTRINGν
  fc_write(&LEN_PSTRING,   sizeof(int), fp);
  fc_write(PSTRING,        LEN_PSTRING, fp);

  // CATEGORYν
  fc_write(&CNT_CATEGORY,  sizeof(int), fp);
  fc_write(CATEGORIES, sizeof(pIMIZ_t) * CNT_CATEGORY, fp);

  // ARCLISTν
  fc_write(&CNT_ARCLIST,  sizeof(int), fp);
  fc_write(ARCLIST, sizeof(pNODE_t **) * CNT_ARCLIST, fp);

  // FUNCGν
  fc_write(&CNT_FUNCG,  sizeof(int), fp);
  fc_write(FUNCG, sizeof(gFUNC_t) * CNT_FUNCG, fp);

  // pPATNν
  f_make_pattern_last(); //ǽȹֹ
  fc_write(PBASE.base_patn, sizeof(pPATN_t) * PBASE.all_patn, fp);

  // pFACTν
  fc_write(PBASE.base_fact, sizeof(pFACT_t) * PBASE.all_fact, fp);

  // pNODEν
  fc_write(PBASE.base_node, sizeof(pNODE_t) * PBASE.all_node, fp);

  fclose(fp);
}
/*-----------------------------------------------------------------------------
  ARCLISTν
-----------------------------------------------------------------------------*/
int f_output_ARCLIST (FILE *fp) {

  int       i, rel;
  pNODE_t **ptr;

  ptr = ARCLIST;

  for (i=0; i<CNT_ARCLIST; i++) {
    rel =  *ptr - PBASE.base_node;
    *ptr = (pNODE_t *)rel;
    ptr++;
  }

  fc_write(&CNT_ARCLIST,  sizeof(int), fp);
  fc_write(ARCLIST, sizeof(pNODE_t **) * CNT_ARCLIST, fp);

  ptr = ARCLIST;

  for (i=0; i<CNT_ARCLIST; i++) {
    rel =  (int)*ptr;
    *ptr = PBASE.base_node + rel;
    ptr++;
  }
}
//-----------------------------------------------------------------------------
int f_usage (char *argv0) {

  fprintf(stderr, "\nusage: %s  arg1 [arg2 arg3 arg4 arg5]\n\n", argv0);
  fprintf(stderr, "    arg1 = ʸѥ󡦥ե̾   (in)\n");
  fprintf(stderr, "    arg2 = ѥ󡦥ޥåץե̾ (out)\n");
  fprintf(stderr, "    arg3 = ؿޥåסե̾     (in)\n");
  fprintf(stderr, "    arg4 = ̣°ɥե̾   (in)\n");
  fprintf(stderr, "    arg5 = 켭(aisam)ե̾  (in)\n\n");
  exit(-1);
}
/*-----------------------------------------------------------------------------

  argv[ ]                argc   2   3   4   5   6     default
       1. ʸѥ                        
       2. - or ϥޥå                     1.Ƭ 'map.'
       3. - or ؿޥå                       ./map.function
       4. - or ̣°                           ./imizokusei.lis
       5. - or 켭                             ./ruigo.dic

-----------------------------------------------------------------------------*/
int f_set_argument (int argc, char *argv[], char args[6][256]) {

  int   i;

  if ((argc < 2) || (argc > 6)) f_usage(argv[0]);

  for (i=0; i<argc; i++) strcpy(args[0], argv[0]);

  // argc : 2  6
  strcpy(args[0], argv[0]);
  strcpy(args[1], argv[1]);
  sprintf(args[2], "map.%s", args[1]);
  strcpy(args[3], "./map.function");
  strcpy(args[4], "./imizokusei.lis");
  strcpy(args[5], "./ruigo.dic");

  switch (argc) {
  case 6: // ʸ  ؿ ̣ 
    if (strcmp(argv[5], "-") != 0) strcpy(args[5], argv[5]);
  case 5:
    if (strcmp(argv[4], "-") != 0) strcpy(args[4], argv[4]);
  case 4: // ʸ  ؿ
    if (strcmp(argv[3], "-") != 0) strcpy(args[3], argv[3]);
  case 3: // ʸ 
    if (strcmp(argv[2], "-") != 0) strcpy(args[2], argv[2]);
  }
}
/*-----------------------------------------------------------------------------
  message  stderr ɽ 0 ֤
-----------------------------------------------------------------------------*/
int f_error (int who, char message[], ...) {

  va_list ap ;

  fflush(stdout);
  fprintf(stderr,
	  "---------------------------------------------------------------\n");
  fprintf(stderr, "ERROR: ");

  va_start(ap, message) ;
  vfprintf(stderr, message, ap) ;
  va_end(ap) ;

  fprintf(stderr, " (line=%d, error-type=#%d)\n\n", PTN_LINE, who);
  fprintf(stderr, "%s:%s\n", PTN_ID, PTN_IMAG);

  ERR_PATN++;
  //exit(0);
  return 0;
}
//-----------------------------------------------------------------------------
int f_split (uchar *src, uchar sym, uchar obj[][512]) {

  int     sc=0;
  uchar  *p1=src, *p2;

  while (p2 = strchr(p1, sym)) {
    strcpy(obj[sc++], fc_substr(p1, p2-1));
    p1 = p2 + 3;
  }

  strcpy(obj[sc++], p1);

  return sc;
}
//-----------------------------------------------------------------------------
// ȹ礻
//-----------------------------------------------------------------------------
int f_gen_perm (int n) {

  int k;
  int nn;
  int ok[4096];
  int p[4096];

  nn = n;
  for (k = 1; k <= n; k++) ok[k] = 1;
  for (k = 1; k <= n; k++) f_gen_perm_sub(p, 0, k, nn, ok);
}
//-----------------------------------------------------------------------------
int f_gen_perm_sub(int p[], int pos, int k, int nn, int ok[]) {

  int i;

  p[pos] = k;

  if (pos == nn - 1) {
    for (i=0; i<nn; i++) GENPERM[CNT_GENPERM++] = p[i];
    GENPERM[CNT_GENPERM++] = -1;
  }
  else {
    ok[k] = 0;
    for (i = 1; i <= nn; i++)
      if (ok[i]) f_gen_perm_sub(p, pos + 1, i, nn, ok);
    ok[k] = 1;
  }
}
/*-----------------------------------------------------------------------------
  ̣°ɤŸ
-----------------------------------------------------------------------------*/
int f_setup_imizokusei (FILE  *fp) {

  char   buf[256];
  int    c1, c2, lines;

  memset(&NI_CODE[0], 0x00, sizeof(NI_CODE));
  memset(&NK_CODE[0], 0x00, sizeof(NK_CODE));
  memset(&NY_CODE[0], 0x00, sizeof(NY_CODE));

  while (fgets(buf, 255, fp)) {
    lines++;
    buf[7] = buf[12] = 0;
    c1 = atoi(&buf[3]);
    c2 = atoi(&buf[8]);
    if (c1 < 1)
      fc_abort("̣° Ͱ襨顼 %d ", lines);
    switch (buf[1]) {
    case 'I':
      if (c1 > MAX_NI) fc_abort("̣° Ͱ襨顼 %d ", lines);
      NI_CODE[c1] = c2;
      break;
    case 'K':
      if (c1 > MAX_NK) fc_abort("̣° Ͱ襨顼 %d ", lines);
      NK_CODE[c1] = c2;
      break;
    case 'Y':
      if (c1 > MAX_NY) fc_abort("̣° Ͱ襨顼 %d ", lines);
      NY_CODE[c1] = c2;
      break;
    }
  }
  fclose(fp);
}
/*-----------------------------------------------------------------------------
  ̣°ΥåȾȹԽ
     zf->imiz : (ex) "NI:xxx,NK:xxx,NY:xxx,KR:xxx"
-----------------------------------------------------------------------------*/
int f_edit_imizokusei (zFACT_t *zf, pFACT_t *pf) {

  char     *p1, *p2, src[4096], key[8], wrk[4096];
  char     nega;
  int      code;
  pIMIZ_t  edit;

  // zf->imiz Ƥå, edit Խ

  memset(&edit, 0x00, sizeof(pIMIZ_t));

  sprintf(src, "%s,", zf->imiz);  // ԽΤ ','ɲ
  p1 = &src[0];

  while (p2=strchr(p1, ',')) {
    *p2 = 0;

    if (memcmp(p1, "KR:", 3) == 0) {
      if (strlen(p1+3) > 7)
	return(f_error(1011, "̣° ɡ顼 %s", p1));
      memset(key, 0x20, sizeof(key));
      memcpy(key, p1+3, strlen(p1+3));
      if (aiReadRec(KRDIC_DES, wrk, AI_GE, key, 0) == AI_ERR)
	return(f_error(1012, "̣° ɡ顼 %s", p1));
      strcpy(edit.KR[edit.KRc++], p1+3);
    }
    else { // NI, NK, NY
      if (strcmp(p1+3, "*") == 0) code = 1;
      else                        code = atoi(p1+3);
      if (code < 0) {
	nega = 1;
	code = abs(code);
      }
      else
	nega = 0;

      if (code < 1)
	return(f_error(1001, "̣° Ͱ襨顼 %s", p1));

      if (memcmp(p1, "NI:", 3) == 0) {
	if (code > MAX_NI)
	  return(f_error(1002, "̣° Ͱ襨顼 %s", p1));
	edit.NIx[edit.NIc] = code;
	edit.NIy[edit.NIc] = NI_CODE[code]; // MAX
	if (nega) edit.NIm[edit.NIc] = 1;
	edit.NIc++;
      }
      else if (memcmp(p1, "NK:", 3) == 0) {
	if (code > MAX_NK)
	  return(f_error(1003, "̣° Ͱ襨顼 %s", p1));
	edit.NKx[edit.NKc] = code;
	edit.NKy[edit.NKc] = NK_CODE[code]; // MAX
	if (nega) edit.NKm[edit.NKc] = 1;
	edit.NKc++;
      }
      else if (memcmp(p1, "NY:", 3) == 0) {
	// 42˶
	if (nega) {  // NY:-xxxx
	             // 01234567
	  if (strlen(p1+4) == 4) {
	    *(p1+6) = 0;
	    code = atoi(p1+4);
	  }
	}
	else if (strlen(p1+3) == 4) {
	  *(p1+5) = 0;
	  code = atoi(p1+3);
	}
	if (code > MAX_NY)
	  return(f_error(1004, "̣° Ͱ襨顼 %s", p1));
	edit.NYx[edit.NYc] = code;
	edit.NYy[edit.NYc] = NY_CODE[code]; // MAX
	if (nega) edit.NYm[edit.NYc] = 1;
	edit.NYc++;
      }
      else
	return(f_error(1005, "̣° ̵楨顼 %s", p1));
    }
    p1 = p2 + 1;
  }

  // edit ̣°ΥХΰϿ
  //  ̣°,ʸѥեƱΥǡ̤ˤΤ
  //  Хΰͭƻ񸻤ޤ

  pf->imiz = f_store_CATEGORY(&edit);

  return 1;
}
/*-----------------------------------------------------------------------------
 бĤå
----------------------------------------------------------------------------*/
uchar *f_find_close_kakko (char s1, char s2, uchar *src) {

  int  c=0;

  for (; *src!=0; src++) {
    if (*src == s1) {
      c++;
    }
    else if (*src == s2) {
      if (--c == 0) return src;
    }
  }

  return NULL;
}
//-----------------------------------------------------------------------------
uchar *f_show_image (int size, zFACT_t *fact) {

  static uchar image[256];

  if (fact->vnum > 0)
    sprintf(image, "%s%d", fact->imag, fact->vnum);
  else 
    strcpy(image, fact->imag);

  if (size == 0) return(&image[0]);
  
  return(fc_short_image(size, image));
}
//-----------------------------------------------------------------------------
char  *f_maton_image (uchar *maton) {

  static char image[256];

  int    i;
  uchar *p1;

  image[0] = 0;

  for (p1=maton; *p1!=0; p1+=3) {
    if (*p1 != ' ') {
      i = atoi(fc_substr(p1+1, p1+2));
      sprintf(&image[strlen(image)], " %s", f_show_image(0, &ZPTN.fact[i]));
    }
  }

  return &image[0];
}
//-----------------------------------------------------------------------------
int f_display_all () {

  int   i;

  PATN = PBASE.base_patn;

  for (i=0; i<PBASE.all_patn; i++) {
    fc_display_pPATN("");
    fc_display_pNODE(0);
    fc_display_pNODE(1);
    PATN++;
  }
}
//-----------------------------------------------------------------------------
int f_display_automaton (char *mark, uchar *maton) {

  int    i;
  uchar *p1;

  printf("%s", mark);

  for (p1=maton; *p1!=0; p1+=3) {
    i = atoi(fc_substr(p1+1, p1+2));
    if      (*p1 == '[') printf(" [");  // show_image="<...>" ξ礢
    else if (*p1 == ']') printf(" ]");  // show_image="<...>" ξ礢
    else            printf(" %s", f_show_image(0, &ZPTN.fact[i]));
  }
  printf("\n");
}
//-----------------------------------------------------------------------------
int f_display_zPATN (char *mark) {

  int    i;

  printf("----------------------------------------------------------------\n");
  printf("zPATN  %s fc=%d\n\n", mark, ZPTN.fc);

  // Ǥɽ
  for (i=0; i<ZPTN.fc; i++) {
    f_display_zFACT(ZPTN.fact[i]);
  }    
}
//-----------------------------------------------------------------------------
int f_display_zFACT (zFACT_t fact) {

  int     i, j;
  uchar   wrk1[4096];

  if (fact.end) {
    printf("(top=#%02d end=#%02d)\n", fact.top, fact.end);
  }

  printf("#%02d %c %d z=%d", fact.num, fact.type, fact.mode, fact.zmac);
  if (fact.vsym) printf(" $%d", fact.vsym);
  else               printf("   ");
  fflush(stdout);

  printf(" %-10s", f_show_image(10, &fact));

  printf(" [] n=%d t=%d",  fact.attr.nin_nest, fact.attr.nin_type);
  printf("  () g=%d t=%d", fact.attr.sen_grup, fact.attr.sen_type);
  printf("  {} g=%d t=%d", fact.attr.goj_grup, fact.attr.goj_type);
  if (fact.attr.nin_nest > 0) {
    strcpy(wrk1, "  []");
    for (j=0; j<fact.attr.nin_nest; j++) {
      sprintf(&wrk1[strlen(wrk1)], " g%d=%d", j, fact.attr.nin_grup[j]);
    }
    printf("%s", wrk1);
  }

  if (fact.imiz[0] != 0) printf(" imi %s", fact.imiz);

  if (fact.gc) {
    printf(" gc=%d", fact.gc);
    for (i=0; i<fact.gc; i++) {
      printf(" %s", fact.gnam[i]);
    }
  }

  printf("\n");
}
//-----------------------------------------------------------------------------
int f_display_linkage () {

  int      i, j;
  zMATN_t *zm, *vx;
  char     wrk0[512], wrk1[512], wrk2[512], mark[512];

  printf("------------------------------------------------------------");

  for (i=0; i<ZC; i++) {
    zm = &ZMATN[i];
    sprintf(mark, "\n#%02d. ", i);
    f_display_linkage_sub(1, mark, zm->matn);
    if (zm->link) {
      for (j=0; j<zm->link; j++) {
	//if (zm->ldel[j]) continue;
	strcpy(wrk2, fc_substr(zm->matn + zm->lpos[j],
			       zm->matn + zm->lpos[j] + 2));
	f_display_linkage_sub(0, "\n  ", wrk2);
	sprintf(wrk1, "  #%2d. ", zm->lnum[j]);
	vx = &ZMATN[zm->lnum[j]];
	strcpy(wrk2, fc_substr(vx->matn + zm->lbak[j],
			       vx->matn + zm->lbak[j] + 2));
	f_display_linkage_sub(0, wrk1, wrk2);
	printf("  ldel(%d) lnum(%2d) lpos(%2d) lbak(%2d)\n",
	   zm->ldel[j], zm->lnum[j], zm->lpos[j], zm->lbak[j]);
      }
    }

    strcpy(wrk0, zm->matn);

    if (zm->flen) {
      strcpy(wrk1, zm->matn);
      wrk1[zm->flen] = 0;
      sprintf(mark, "\n    #%02d ", zm->fnum);
      f_display_linkage_sub(0, mark, wrk1);
      printf("  fnum(%2d) flen(%2d)\n", zm->fnum, zm->flen);

      memset(wrk0, ' ', zm->flen);
    }
    else {
      printf("\n   ---\n");
    }

    if (zm->rlen) {
      wrk0[zm->rpos] = 0;
      if (memcmp(wrk0, BLANK, strlen(wrk0)) == 0)
	printf("   ---\n");
      else
	f_display_linkage_sub(1, "       ", wrk0);
      strcpy(wrk1, zm->matn + zm->rpos);
      sprintf(mark, "    #%02d ", zm->rnum);
      f_display_linkage_sub(0, mark, wrk1);
      printf("  rnum(%2d) rlen(%2d) rpos(%2d) ryou(%2d)",
       zm->rnum, zm->rlen, zm->rpos, zm->ryou);
      if (zm->rdel) printf("   ");
      printf("\n");
    }

    else {
      if (memcmp(wrk0, BLANK, strlen(wrk0)) == 0)
	printf("   ---\n");
      else
	f_display_linkage_sub(1, "       ", wrk0);
      printf("   ---\n");
    }
  }
}
//-----------------------------------------------------------------------------
int f_display_linkage_sub (int terpri, char *mark, char *matn) {

  int      i;
  uchar    wrk[512];
  char    *p1;
  zFACT_t *fact;

  printf("%s", mark);

  for (p1=matn; *p1!=0; p1+=3) {
    if (*p1 != ' ') {
      i = atoi(fc_substr(p1+1, p1+2));
      fact = &ZPTN.fact[i];
      strcpy(wrk, f_show_image(0, fact));
      printf("%s ", wrk);
    }
  }

  if (terpri) printf("\n");
}
//-----------------------------------------------------------------------------
int f_display_zNODE () {

  int       i, j;
  zNODE_t  *np;
  pFACT_t  *fact;
  char     *p1;

  printf("------------------------------------------------------------\n");
  printf("ZC=%d ZNC=%d\n\n", ZC, ZNC);

  for (i=0; i<ZNC; i++) {

    np = &ZNODE[i];

    printf("numb=%d zn=%2d  pos=%3d  top=%d  fnum=%3d  ac=%2d",
       np->numb, np->zn, np->pos, np->top, np->fnum, np->ac);

    if (np->top != 9) {
      fact = PATN->top_fact + np->fnum;
      printf("  %s", fc_show_image(0, fact));
    }

    printf("\n");

    for (j=0; j<np->ac; j++) {
      printf ("  arc[%d]  azn=%2d  apos=%2d anum=%2d",
	  j+1, np->azn[j], np->apos[j], np->anum[j]);

      p1 = ZMATN[np->azn[j]].matn + np->apos[j];
      fact = PATN->top_fact + atoi(fc_substr(p1+1, p1+2));
      printf("  %s\n", fc_show_image(0,fact));
    }
    printf("\n");
  }
}
/*-----------------------------------------------------------------------------
  ǽȹֹ
-----------------------------------------------------------------------------*/
int f_make_pattern_last () {

  int      i, j;
  pPATN_t *patn;
  pFACT_t *fact;

  patn = PBASE.base_patn;

  for (i=0; i<PBASE.all_patn; i++) {

    fact = patn->top_fact + patn->cnt_fact - 1;

    for (j=patn->cnt_fact - 1; j>0; j--) {
      if (fact->type == 'J') {
	patn->last_fn = j;
	break;
      }
      fact--;
    }

    patn++;
  }
}
//-----------------------------------------------------------------------------
/*
  stage01 : ѥʸ   ZPTN
    stage01_1 : ܥåỌ̇̄°γΥ
    stage01_2 : ѥʸ老ȤˤޤȤ
                <...>  [...] ѹ
    stage01_3 : ʤɤط
                '/case' ʤɤΥ
		#n[...] ʤɤ '#'
		ѿ̾ѿֹ, ̣°ΥХ
		. ȸؿ̾ΥХ
		^ ؿ̾ΥХ

  stage02 : åΥ󥿥åå

  stage03 : ͥȾκǤΥ롼ײ

  stage04 : ɬܻ̥ޥåפκ

  stage05 : ȥޥȥκ  QUE[]
    stage05_1 : ١κ
    stage05_2 : ֲѻ국 $n^{...}
    stage05_3 : 򵭹 (...|...|...)
    stage05_4 : Ǥǵ  [...]
    stage05_5 : Ǥջ국  {...}
    stage05_6 : QUE ȹפǤ  ZPTN.matn[]

  stage06 : κ
    #n , $n, ̴ؿ('Z'), ޥؿ('M')礹Ǥ
    Ƭȹֹ  top
    ǽȹֹ  end
    Ǥ vsym

  stage07 : פǤκ
            ȹǤˡ#ZM ֤
	    åࡢV ϼΤƤ
	    ȥޥȥ(ZPTN.matn)Ʊ
    f_stage07_1

  stage08 : ȥޥȥΰ  ZMATN
    f_stage08_1 : פlink
    f_stage08_2 : פjump
    f_stage08_3 : linkκĴ

  stage09 : ZPTN  pPATN

  stage10 : Ρɤ
    f_stage10_1 : ΡɡꥹȤκ ZMATN[]  ZNODE[]
    f_stage10_2 : ΡɡꥹȤΥ֥
    f_stage10_3 : Ρɤ         ZNODE[]  pNODE[]

  stage11 : ̴ؿ  ѥǤ zmac ꤹ
*/
/*-----------------------------------------------------------------------------
  ɬܻ̥ޥåɬ̤η׻
-----------------------------------------------------------------------------*/
int f_check_jmap () {

  int      i, j, v, jc, total;
  uchar   *p1;
  pPATN_t *patn;
  pFACT_t *fact;
  int     val[ 4096];
  char    map[24000];

  memset(map, 0x00, sizeof(map));

  jc = total = 0;
  patn = PBASE.base_patn;

  for (i=0; i<PBASE.all_patn; i++) {

    // ѥΥӥåȤOFF
    for (j=0; j<jc; j++) {
      map[val[j]] = 0;
    }

    jc = 0;
    fact = patn->top_fact;

    for (j=0; j<patn->cnt_fact; j++) {  // ٤ƤǤ Loop
      if (fact->mode == 1) {      // ɬ
	if (fact->type == 'J') {      // 
	  for (p1=fact->imag; *p1!=0; p1+=2) {
	    if (memcmp(p1, "", 2) != 0) {
	      v = *p1 * 256 + *(p1+1) - A1A1;
	      if (map[v] == 0) {
		val[jc++] = v;
		map[v]    = 1;
	      }
	    }
	  }
	}
      }
      fact++;
    }

    total += jc;
    patn->cnt_jmap = jc;
    patn++;
  }

  PBASE.all_jmap = total;
}
//-----------------------------------------------------------------------------
