/*-----------------------------------------------------------------------------
  ؿ ؿ ӷѿ ѿ Υ ޥåפ
-----------------------------------------------------------------------------*/
#include "common.h"

// ӷѿ + ؿ + ؿ
#define  ALLOC_VARS    1024   // ѿ/ؿθĿ
#define  ALLOC_JMAP    4096   // ̥ޥåפθĿ

// ؿ + Υ
#define  ALLOC_VARA   10000   // ؿ/θĿ
#define  ALLOC_NODE   10000   // ΡɤθĿ
#define  ALLOC_ARC    10000   // θĿ

typedef struct zVARS  zVARS_t;

struct zVARS {
  char     type;       // S=Sѿ  G=ؿ  Y=ؿ
  uchar   *name;       // ؿ̾ (FSTRING)

  char     ckind;      // 't' or 'h' or 'x'
  char     cnot;       // 1=, 0=
  uchar   *cvalu;      // Ϣ (ctype = 't' or 'h'ΤȤ) (FSTRING)

  short    cc;        //   ο (*1)
  short    vc  [MAX_zCOND];             // ͤο (*2)
  char     kind[MAX_zCOND][MAX_zVALU];  // 勵 (*3)
  char     not [MAX_zCOND][MAX_zVALU];  // 1=, 0=
  char     proc[MAX_zCOND][MAX_zVALU];  // ֥ե饰 (*4)
  uchar   *valu[MAX_zCOND][MAX_zVALU];  //  (FSTRING)
};

uchar *ZSTRING;

int    LEN_ZSTRING = 0;
int    CNT_ZWORDS  = 0;
int    LEN_ZWORDS[MAX_FWORDS];

int  MAX_CC1=0, MAX_VC1=0;
int  MAX_CC2=0, MAX_VC2=0;

//     282        3       ckind = t h x
//      16        3       ckind = x

int    f_parse_xtype (char type, char *filename);
int    f_parse_atype (char kind, char *filename);
uchar *f_parse_xtype_sub (zVARS_t *vars, uchar buf[], uchar *p1, int proc);

//-----------------------------------------------------------------------------
int main (int argc, char *argv[]) {

  char  param[6][256];

  if (argc != 2) f_usage(argv[0]);

  // ե̾μ
  f_get_param(argv[1], &param[0][0]);

  // ѥʸΰγ
  FSTRING = (uchar *)calloc(1, MAX_FSTRING);
  ZSTRING = (uchar *)calloc(1, MAX_FSTRING);

  // ΰγ
  f_initialize_xtype();
  f_initialize_atype();

  // ޥå׺
  f_parse_xtype('G', param[0]);   // ؿ
  f_parse_xtype('Y', param[1]);   // ؿ
  f_parse_xtype('S', param[2]);   // ӷѿ

  f_parse_atype('A', param[3]);   // ѿ
  f_parse_atype('R', param[4]);   // Υ

  f_link_atype();  // (ѿ̾)褹
  f_set_endp();    // Ρɥݥ󥿤򥻥åȤ

  //f_trace_atype();  // AѿΥȥޥȥɽ

  // ؿλ̥ޥå׺
  f_make_jmap();

  // ̤ɽ
  f_display_xtype_all();
  f_display_atype_all();

  //vx("all MAX  CC=%d  VC=%d\n", MAX_CC1, MAX_VC1);
  //vx("x   MAX  CC=%d  VC=%d\n", MAX_CC2, MAX_VC2);

  f_output(param[5]);
}
//-----------------------------------------------------------------------------
int f_get_param (char *argv1, char param[][256]) {

  int   n=0;
  char  buf[256], *p1;
  FILE *fp;

  if (! (fp = fopen(argv1, "r")))
    fc_abort(";;; can't open '%s'\n\n", argv1);

  while (fgets(buf, 255, fp)) {
    buf[strlen(buf)-1] = 0;
    if (p1 = strchr(buf, '#')) *(p1) = 0;
    while (buf[0] == ' ') strcpy(&buf[0], &buf[1]);
    while (buf[strlen(buf)-1] == ' ') buf[strlen(buf)-1] = 0;
    if (buf[0] != 0) {
      if (n == 6)
	fc_abort(";;; too many parameter '%s'\n\n", buf);
      strcpy(param[n++], buf);
    }
  }

  fclose(fp);

  if (n != 6)
    fc_abort(";;; too few parameter '%s'\n\n", buf);
}
//-----------------------------------------------------------------------------
aVARA_t *f_new_VARA () {

  if (aBASE.all_vara == ALLOC_VARA) fc_abort("ERROR: exceed ALOC_VARA\n");

  return(aBASE.base_vara + aBASE.all_vara++);
}
//-----------------------------------------------------------------------------
aNODE_t *f_new_NODE () {

  if (aBASE.all_node == ALLOC_NODE) fc_abort("ERROR: exceed ALOC_NODE\n");

  return(aBASE.base_node + aBASE.all_node++);
}
//-----------------------------------------------------------------------------
aARC_t *f_new_ARC () {

  if (aBASE.all_arc == ALLOC_ARC) fc_abort("ERROR: exceed ALOC_ARC\n");

  return(aBASE.base_arc + aBASE.all_arc++);
}
/*-----------------------------------------------------------------------------
  ʸ word  FSTRING ¸ߤ뤫Ĵ١
  ¸ߤСΥɥ쥹֤
  ¸ߤʤСword ʸ FSTRING ɲäơΥɥ쥹֤
-----------------------------------------------------------------------------*/
uchar *f_store_FSTRING (uchar *word) {

  int     i, pos, lenW;
  static uchar  *str;

  str = FSTRING;
  pos = 0;

  for (i=0; i<CNT_FWORDS; i++) {
    if (strcmp(word, str) == 0) return str;
    //vs("\nstr #%d pos=%d  %d[%s]\n\n", i+1, pos, strlen(str), str);
    str += LEN_FWORDS[i] + 1;
    pos += LEN_FWORDS[i] + 1;
  }

  //           0123456789
  //  len=3    abc0def0xyz
  //               |   |
  //               |   str(4+3+1)=8
  //              str(4)
  //
  // word ̤Ͽñ, str ɲä٤FSTRINGΥɥ쥹ؤƤ

  lenW = strlen(word);

  if ((LEN_FSTRING + lenW + 1) > MAX_FSTRING)
    fc_abort(";;; ERROR : exceed size FSTRING\n");

  if ((CNT_FWORDS + 1) > MAX_FWORDS)
    fc_abort(";;; ERROR : exceed size FWORDS\n");

  LEN_FSTRING += lenW + 1;
  LEN_FWORDS[CNT_FWORDS++] = lenW;
  
  //vs("\npos %d\n", pos);

  strcpy(str, word);

  {
    uchar *p = FSTRING;

    //vs("\nCNT_FWORDS=%d LEN_FSTRING=%d\n\n", CNT_FWORDS, LEN_FSTRING);

    for (i=0; i<CNT_FWORDS; i++) {
      //vs("#%02d  %d  %d[%s]\n\n", i+1, LEN_FWORDS[i], strlen(p), p);
      p += LEN_FWORDS[i] + 1;
    }
  }

  return str;
}
/*-----------------------------------------------------------------------------
  ʸ word  ZSTRING ¸ߤ뤫Ĵ١
  ¸ߤСΥɥ쥹֤
  ¸ߤʤСword ʸ ZSTRING ɲäơΥɥ쥹֤
-----------------------------------------------------------------------------*/
uchar *f_store_ZSTRING (uchar *word) {

  int     i, lenW;
  static uchar  *str;

  str = ZSTRING;

  for (i=0; i<CNT_ZWORDS; i++) {
    if (strcmp(word, str) == 0) return str;
    str += LEN_ZWORDS[i] + 1;
  }

  //           0123456789
  //  len=3    abc0def0xyz
  //               |   |
  //               |   str(4+3+1)=8
  //              str(4)
  //
  // word ̤Ͽñ, str ɲä٤ZSTRINGΥɥ쥹ؤƤ

  lenW = strlen(word);

  if ((LEN_ZSTRING + lenW + 1) > MAX_FSTRING)
    fc_abort(";;; ERROR : exceed size ZSTRING\n");

  if ((CNT_ZWORDS + 1) > MAX_FWORDS)
    fc_abort(";;; ERROR : exceed size ZWORDS\n");

  LEN_ZSTRING += lenW + 1;
  LEN_ZWORDS[CNT_ZWORDS++] = lenW;
  strcpy(str, word);

  return str;
}

/*-----------------------------------------------------------------------------
  ʸ src ʬ䤷 obj[][] ˳Ǽ
-----------------------------------------------------------------------------*/
int f_parse_string (uchar *src, uchar obj[][4096]) {

  uchar  wrk[4096], *p1, *p2;

  int    n=0;

  strcpy(wrk, src);
  p1 = &wrk[0];

  /* ߥʹߤ */
  if ((p2 = strchr(p1, ';')) != NULL) *(p2) = 0;

  /* ִ֤ */
  while ((p2 = strchr(p1, '\t')) != NULL) *(p2) = ' ';

  /* Զκ */
  while (*p1 == ' ') p1++;

  /* κ */
  while (1) {
    if (*p1 == 0) break;
    if (*(p1+strlen(p1)-1) == ' ')
      *(p1+strlen(p1)-1) = 0;
    else
      break;
  }

  /* ʬ */
  while ((p2 = strchr(p1, ' ')) != NULL) {
    *(p2) = 0;
    strcpy(&obj[n++][0], p1);
    p1 = p2 + 1;
    while (*p1 == ' ') p1++;  /* Ϣ³κ */
  }

  if (*(p1) != 0) strcpy(&obj[n++][0], p1);

  return(n);
}
/*---------------------------------------------------------------------------*/
int f_source_error (int where, uchar *src) {

  fprintf(stderr, "--------------------------------------------------\n");
  fprintf(stderr, "?? ؿ顼 (%d)\n\n", where);
  fprintf(stderr, "%s\n", src);
  fprintf(stderr, "--------------------------------------------------\n");
  exit(-1);
}
/*---------------------------------------------------------------------------*/
int f_usage (char *name) {

  fc_abort("\nusage:  %s ե̾ꥹ\n\n", name);
}
/*-----------------------------------------------------------------------------
  ӷѿ/ؿΰݤ
-----------------------------------------------------------------------------*/
int f_initialize_xtype () {

  memset((char *)&xBASE, 0x00, sizeof(xBASE));

  xBASE.base_vars = (xVARS_t *)fc_alloc("xtype", ALLOC_VARS, sizeof(xVARS_t));
  xBASE.base_jmap = (xJMAP_t *)fc_alloc("xjmap", ALLOC_JMAP, sizeof(xJMAP_t));
}
/*-----------------------------------------------------------------------------
  ѿΥΰݤ
-----------------------------------------------------------------------------*/
int f_initialize_atype () {

  memset((char *)&aBASE, 0x00, sizeof(aBASE));

  aBASE.base_vara = (aVARA_t *)calloc(ALLOC_VARA, sizeof(aVARA_t));
  aBASE.base_node = (aNODE_t *)calloc(ALLOC_NODE, sizeof(aNODE_t));
  aBASE.base_arc  = (aARC_t  *)calloc(ALLOC_ARC,  sizeof(aARC_t));
}
/*-----------------------------------------------------------------------------
  ؿե˽Ϥ
-----------------------------------------------------------------------------*/
int f_output (char *filename) {

  FILE  *fp;

  if ((fp = fopen(filename, "w")) == NULL)
    fc_abort("can't open '%s'\n", filename);

  // VERSIONν

  fprintf(fp, "%s\n", VERSION_FUNCTION);

  // FSTRINGν
  fc_write(&LEN_FSTRING,   sizeof(int), fp);
  fc_write(&CNT_FWORDS,    sizeof(int), fp);
  fc_write(&LEN_FWORDS[0], MAX_FWORDS,  fp);
  fc_write(FSTRING,        LEN_FSTRING, fp);

  /*
  fprintf(stderr, "LEN_FSTRING = %d,  CNT_FWORDS = %d\n",
	  LEN_FSTRING, CNT_FWORDS);
  */

  // ؿν
  f_output_xtype(fp);
  f_output_atype(fp);

  fclose(fp);

  vx("\n;;; finished\n\n");
}
/*---------------------------------------------------------------------------*/
int f_output_xtype (FILE *fp) {

  xVARS_t *vars = xBASE.base_vars;
  xJMAP_t *jmap = xBASE.base_jmap;

  int    i, cc, vc;

  // xBASE ν
  fc_write(&xBASE, sizeof(xBASE), fp);

  // xVARS ν : name & cvalu 򥢥ɥ쥹а֤Ѵ
  for (i=0; i<xBASE.all_vars; i++) {
    vars->name = (uchar *)(vars->name - FSTRING);
    if (vars->cvalu) {
      vars->cvalu = (uchar *)(vars->cvalu - FSTRING);
    }
    else {
      for (cc=0; cc<vars->cc; cc++) {
	for (vc=0; vc<vars->vc[cc]; vc++) {
	  vars->valu[cc][vc] = (uchar *)(vars->valu[cc][vc] - FSTRING);
	}
      }
    }
    fc_write(vars, sizeof(xVARS_t), fp);
    vars++;
  }

  // xJMAP ν

  for (i=0; i<xBASE.all_jmap; i++) {
    fc_write(jmap, sizeof(xJMAP_t), fp);
    jmap++;
  }
}
/*---------------------------------------------------------------------------*/
int f_output_atype (FILE *fp) {

  aVARA_t *vara = aBASE.base_vara;
  aNODE_t *node = aBASE.base_node;
  aARC_t  *arc  = aBASE.base_arc;
  int    i;

  // aBASE ν
  fc_write(&aBASE, sizeof(aBASE), fp);

  // aVARA ν : name & top_node 򥢥ɥ쥹а֤Ѵ
  for (i=0; i<aBASE.all_vara; i++) {
    vara->name = (uchar *)(vara->name - FSTRING);
    vara->top_node =
      (aNODE_t *)((char *)vara->top_node - (char *)aBASE.base_node);
    fc_write(vara, sizeof(aVARA_t), fp);
    vara++;
  }

  // aNODE ν top_arc 򥢥ɥ쥹а֤Ѵ
  for (i=0; i<aBASE.all_node; i++) {
    //xshow("node #%d [%d] %x top_arc = %x", i,node->num, node, node->top_arc);
    node->top_arc =
      (aARC_t *)((char *)node->top_arc - (char *)aBASE.base_arc);
    //xshow("  %x\n", node->top_arc);
    fc_write(node, sizeof(aNODE_t), fp);
    node++;
  }

  // aARC ν cond & ptr 򥢥ɥ쥹а֤Ѵ
  for (i=0; i<aBASE.all_arc; i++) {
    //xshow("output arc #%d [%s] %x\n", i, arc->cond, arc);
    arc->cond = (uchar *)(arc->cond - FSTRING);
    if (strchr("SGY", arc->type)) { // ӷѿ/ؿ/ؿ
      arc->ptr = (void *)((char *)arc->ptr - (char *)xBASE.base_vars);
    }
    else if (arc->type == 'A') { // ѿ
      arc->ptr = arc->ptr - (long)aBASE.base_vara;
    }
    fc_write(arc, sizeof(aARC_t), fp);
    arc++;
  }
}
/*-----------------------------------------------------------------------------
  ѿ arc ˵Ҥ줿̤ѿ̾褹
-----------------------------------------------------------------------------*/
int f_link_atype () {

  int    a, s, v;

  aARC_t  *arc;
  aVARA_t *vara;
  xVARS_t *vars;

  arc = aBASE.base_arc;

  for (a=0; a<aBASE.all_arc; a++) {  // ٤Ƥ arc 

    if (arc->type == '?') {  // ̤ѿ

      // ӷѿ򸡺
      vars = xBASE.base_vars;
      for (s=0; s<xBASE.all_vars; s++) {
	if ((vars->type == 'S') &&
	    (strcmp(arc->cond, vars->name) == 0)) {
	  arc->type = 'S';
	  arc->ptr  = vars;
	  break;
	}
	vars++;
      }

      if (arc->type == '?') { // ޤ̤
	// ѿ򸡺
	vara = aBASE.base_vara;
	for (v=0; v<aBASE.all_vara; v++) {
	  if (strcmp(arc->cond, vara->name) == 0) {
	    arc->type = 'A';
	    arc->ptr  = vara;
	    break;
	  }
	  vara++;
	}
      }

      if (arc->type == '?') { // ޤ̤
	//fc_abort(";;; ѿ̾ ̤ [%s]\n", arc->cond);
	fprintf(stderr, ";;; ѿ̾ ̤ [%s]\n", arc->cond);
      }
    }

    arc++;
  }
}
/*-----------------------------------------------------------------------------
  src  ɸɽ  'xxxx' ʸʤ 1 򡢤¾ 0 ֤
-----------------------------------------------------------------------------*/
int f_hyojun_p (uchar *src) {

  uchar  wrk[4096];

  if ((*src == '\'') &&
      (fc_tail_char(src) == '\'')) {
    strcpy(&wrk[0], src+1);
    fc_tail_cut(wrk);
    if (fc_zenkaku_p(wrk)) return 1;
  }

  return 0;
}
/*-----------------------------------------------------------------------------
  Aѿ
    (1) Ρֹȥå
    (2) ΡɤΡֹ¤ؤ
    (3) ƥΡɤλֹȽֹ - 1 (Τޤindexˤ뤿)
-----------------------------------------------------------------------------*/
int f_node_check (aVARA_t *vara) {

  aNODE_t *node, NODE[256];
  aARC_t  *arc;
  int    i, j;
  char   siten, msg[256], list[256];

  // (1) ƥΡɤλֹ  vara ΥΡɿ
  node = vara->top_node;
  for (i=0; i<vara->cnt_node; i++) {
    if (node->num > vara->cnt_node) {
      sprintf(msg, "Aѿ %s  Ρֹ椬ʤ", vara->name); 
      f_source_error(901, msg);
    }
    // ƥνֹ  vara ΥΡɿ
    arc = node->top_arc;
    for (j=0; j<node->cnt_arc; j++) {
      if (arc->end > vara->cnt_node) {
	sprintf(msg, "Aѿ %s  Ρ %d  Ρֹ椬ʤ", 
		vara->name, node->num, arc->end);
	f_source_error(902, msg);
      }
      arc++;
    }
    node++;
  }

  // (2) ΡɤΡֹ¤ؤ
  //   NODE[ֹ] ˥ԡ
  memset(&list[0], 0x00, sizeof(list));
  node = vara->top_node;
  for (i=0; i<vara->cnt_node; i++) {
    siten = node->num - 1;
    if (list[siten] == 1) {
      sprintf(msg, "Aѿ %s  Ρֹ椬ʣƤ", vara->name); 
      f_source_error(903, msg);
    }
    list[siten] = 1;
    memcpy(&NODE[siten], node, sizeof(aNODE_t));
    node++;
  }
  //    NODE[]  ᤹
  memcpy(vara->top_node, &NODE[0], sizeof(aNODE_t) * vara->cnt_node);

  // (3) ƥΡɤλֹ - 1
  node = vara->top_node;
  for (i=0; i<vara->cnt_node; i++) {
    node->num--;
    // ƥνֹ - 1 (pop  -1 Ȥʤ)
    arc = node->top_arc;
    for (j=0; j<node->cnt_arc; j++) {
      arc->end--;
      arc++;
    }
    node++;
  }
}
//-----------------------------------------------------------------------------
uchar *f_parse_xtype_sub (zVARS_t *vars, uchar buf[], uchar *p1, int proc) {

  uchar *p2, save;

  short cc = vars->cc;
  short vc = vars->vc[cc];

  //vx("C: p1 [%s]\n", p1);

  switch (*p1) {

  case '\'': // ɸɽλϤޤ
    //vx("= H =\n");
    if (! (p2 = strchr(p1+1, '\''))) f_source_error(1, buf);
    *p2 = 0;
    if (! fc_zenkaku_p(p1+1)) f_source_error(2, buf);
    vars->kind[cc][vc] = 'H';
    vars->valu[cc][vc] = f_store_ZSTRING(p1+1);
    p1 = p2 + 1;
    break;

  case '-':  // ʻ쥳ɤλϤޤ
    //vx("= -P =\n");
    if (*(p1+1) != '(') f_source_error(8, buf);
    p1++;
    if (! (p2 = strchr(p1, ')'))) f_source_error(3, buf);
    *p2 = 0;
    if (! fc_hinsi_p(p1+1)) f_source_error(4, buf);
    vars->kind[cc][vc] = 'P';
    vars->not [cc][vc] = 1;
    vars->valu[cc][vc] = f_store_ZSTRING(p1+1);
    p1 = p2 + 1;
    break;

  case '(':  // ʻ쥳ɤλϤޤ
    //vx("= P =\n");
    if (! (p2 = strchr(p1, ')'))) f_source_error(3, buf);
    *p2 = 0;
    if (! fc_hinsi_p(p1+1)) f_source_error(4, buf);
    vars->kind[cc][vc] = 'P';
    vars->valu[cc][vc] = f_store_ZSTRING(p1+1);
    p1 = p2 + 1;
    break;
    
  case '~':  // ʻλϤޤ
    //vx("= G =\n");
    for (p2=p1+1; *p2>=0xa1; p2++);
    save = *p2;
    *p2 = 0;
    if (! fc_zenkaku_p(p1+1)) f_source_error(5, buf);
    vars->kind[cc][vc] = 'G';
    vars->valu[cc][vc] = f_store_ZSTRING(p1+1);
    *p2 = save;
    p1 = p2;
    break;
    
  default:
    //vx("= T =\n");
    if (*p1 >= 0xa1) { // ̤λϤޤ
      for (p2=p1+1; *p2>=0xa1; p2++);
      save = *p2;
      *p2 = 0;
      if (! fc_zenkaku_p(p1)) f_source_error(6, buf);
      //vx("cc=%d vc=%d\n", cc, vc);
      vars->kind[cc][vc] = 'T';
      vars->valu[cc][vc] = f_store_ZSTRING(p1);
      *p2 = save;
      p1 = p2;
      //vx("D: p1 [%s]\n", p1);
    }
    else {
      fprintf(stderr, "[%s]\n", p1);
      f_source_error(7, buf);
    }
  }

  if (proc) vars->proc[cc][vc] = 1;

  return(p1);
}
/*-----------------------------------------------------------------------------
  ؿեϤơؿ
-----------------------------------------------------------------------------*/
int f_parse_xtype (char type, char *filename) {

  uchar  buf[4096], src[512][4096], *p1;
  int    end=1, i, n, proc=0;
  FILE  *fp;
  xVARS_t  *vars;
  zVARS_t  pz;

  LEN_ZSTRING = CNT_ZWORDS = 0;

  if ((fp = fopen(filename, "r")) == NULL)
    fc_abort(";;; can't open '%s'\n", filename);

  while (fgets(buf, 4095, fp) != NULL) {
    buf[strlen(buf)-1] = 0;

    if (! (n = f_parse_string(buf, src))) continue;  // ԤɤФ

    if (end) { // ϴؿ̾νиԤ

      memset(&pz, 0x00, sizeof(pz));
      pz.type = type;                     // S or G or Y
      pz.name = f_store_FSTRING(src[0]);  // ؿ̾
      end = 0;
      continue;
    }

    // ؿλ
    if (strcmp(src[0], "end") == 0) {
      end = 1;
      vars = xBASE.base_vars + xBASE.all_vars++;
      if (f_edit_xtype1(&pz, vars)) f_edit_xtype2(&pz, vars);
      continue;
    }

    /*   ǥߥå : ''' = ɸɽλϤޤ     <ɸɽ>
                              '(' = ʻ쥳ɤλϤޤ   (ʻ쥳)
			      '-' = ʻ쥳ɤλϤޤ   -(ʻ쥳)
		              '~' = ̤λϤޤ     ~
			      '&' = ʣ                          */

    for (i=0; i<n; i++) {  // n = ǿ
      p1 = &src[i][0];
      if (strcmp(p1, "&") != 0) {
	while (*p1 != 0) {
	  if (*p1 == ',') {
	    p1++;
	    //if (type == 'S') proc = 1;
	    if ((type == 'S') || (type == 'Y')) proc = 1;
	  }
	  else if (*p1 == '^') {
	    p1++;
	  }
	  else {
	    p1 = f_parse_xtype_sub(&pz, buf, p1, proc);
	    pz.vc[pz.cc]++;
	    proc = 0;
	    //vs("vc = %d\n", pz.vc[pz.cc]);
	  }
	}
      }
    }
    pz.cc++;
    //vs("cc = %d\n", pz.cc);
  }

  fclose(fp);
}
//-----------------------------------------------------------------------------
int f_edit_xtype1 (zVARS_t *pz, xVARS_t *vars) {

  int       cc, vc, sc;
  char      kind, not;
  char      cvalu[8192];

  // CC & VC κͤå
  if (pz->cc > MAX_CC1) MAX_CC1 = pz->cc;

  for (cc=0; cc<pz->cc; cc++) {
    if (pz->vc[cc] > MAX_VC1) MAX_VC1 = pz->vc[cc];
  }

  strcpy(cvalu, " ");

  kind = pz->kind[0][0];
  not  = pz->not [0][0];

  if (! strchr("TH", kind)) return 1;  // ñɽ/ɸɽΤ߰ǽ

  sc = 0;

  for (cc=0; cc<pz->cc; cc++) {

    for (vc=0; vc<pz->vc[cc]; vc++) {

      if (pz->kind[cc][vc] != kind) return 1;   //   T H P G
      if (pz->not [cc][vc] != not)  return 1;   //   ,
      if (pz->proc[cc][vc] == 1)    return 1;

      strcat(cvalu, pz->valu[cc][vc]);
      strcat(cvalu, " ");
      sc++;
    }
  }

  vars->type = pz->type;
  vars->name = pz->name;

  if (kind == 'T') vars->ckind = 't';
  else             vars->ckind = 'h';

  vars->cnot = not;

  // =1 ʤΥ֥󥯤
  if (sc == 1) {
    cvalu[strlen(cvalu)-1] = 0;
    strcpy(&cvalu[0], &cvalu[1]);
  }

  vars->cvalu = f_store_FSTRING(cvalu);

  return 0;
}
//-----------------------------------------------------------------------------
int f_edit_xtype2 (zVARS_t *pz, xVARS_t *vars) {

  int    cc, vc;

  // CC & VC κͤå
  if (pz->cc > MAX_CC2) MAX_CC2 = pz->cc;

  for (cc=0; cc<pz->cc; cc++) {
    if (pz->vc[cc] > MAX_VC2) MAX_VC2 = pz->vc[cc];
  }

  vars->ckind = 'x';
  vars->type  = pz->type;
  vars->name  = pz->name;
  vars->cc    = pz->cc;

  for (cc=0; cc<pz->cc; cc++) {
    vars->vc[cc] = pz->vc[cc];
    for (vc=0; vc<pz->vc[cc]; vc++) {
      vars->kind[cc][vc] = pz->kind[cc][vc];
      vars->not [cc][vc] = pz->not [cc][vc];
      vars->proc[cc][vc] = pz->proc[cc][vc];
      vars->valu[cc][vc] = f_store_FSTRING(pz->valu[cc][vc]);
    }
  }
}
//-----------------------------------------------------------------------------
int f_display_xtype_all () {

  xVARS_t *vars = xBASE.base_vars;

  int    i;

  for (i=0; i<xBASE.all_vars; i++) {
    f_display_xtype(vars);
    vars++;
  }
}
//-----------------------------------------------------------------------------
int f_display_xtype (xVARS_t *vars) {

  short  cc, vc;

  printf("----------------------------------------------------------------\n");

  switch (vars->type) {
  case 'S': printf(" Sѿ"); break;
  case 'G': printf(" ؿ"); break;
  case 'Y': printf(" ؿ"); break;
  default:
    fc_abort("f_display_xtype: unknown vars->type '%c'\n", vars->type);
  }

  printf("  <%c>  %s\n\n", vars->type, vars->name);

  if (vars->ckind != 'x') {
    printf(" ckind=%c  cnot=%d  %d[%s]\n",
	   vars->ckind, vars->cnot, strlen(vars->cvalu), vars->cvalu);
  }
  else {
    printf(" ckind=%c  cc=%d\n", vars->ckind, vars->cc);

    for (cc=0; cc<vars->cc; cc++) {
      printf("\n %2d. vc=%d\n", cc+1, vars->vc[cc]);

      for (vc=0; vc<vars->vc[cc]; vc++) {
	printf("    (%d) %c  not=%d  proc=%d  valu [%s]\n",
	       vc+1, vars->kind[cc][vc], vars->not[cc][vc],
	       vars->proc[cc][vc], vars->valu[cc][vc]);
      }
    }
  }
}
//-----------------------------------------------------------------------------
int f_display_atype_all () {

  aVARA_t *vara = aBASE.base_vara;

  int    i;

  for (i=0; i<aBASE.all_vara; i++) {
    f_display_atype(vara);
    vara++;
  }
}
//-----------------------------------------------------------------------------
int f_display_atype (aVARA_t *vara) {

  aNODE_t *node;

  int    i;

  printf("----------------------------------------------------------------\n");
  printf(" Aѿ %s (node=%d)\n\n", vara->name, vara->cnt_node);

  node = vara->top_node;  // ǽΥΡΰ

  for (i=0; i<vara->cnt_node; i++) {
    f_display_node(node);
    node++;
  }
}
//-----------------------------------------------------------------------------
int f_display_node (aNODE_t *node) {

  int     i;
  aARC_t *arc = node->top_arc;

  printf("  %02d arc=%d\n", node->num, node->cnt_arc);

  for (i=0; i<node->cnt_arc; i++) {
    printf("     <%d> %02d %c %s", i+1, arc->end, arc->type, arc->cond);
    if (arc->opt_i) printf(" *");
    if (arc->opt_g) printf(" ^");
    if (arc->pop)   printf(" ");
    printf("\n");
    arc++;
  }
}
/*-----------------------------------------------------------------------------
  Aѿηϩȥ졼
-----------------------------------------------------------------------------*/
int f_trace_atype () {

  aVARA_t *vara = aBASE.base_vara;
  aNODE_t *node;
  aARC_t  *arc;
  int    i, k;
  char   trace[4096];

  for (i=0; i<aBASE.all_vara; i++) {
    printf("---------- NODE %s\n", vara->name);
    node = vara->top_node;
    arc  = node->top_arc;
    for (k=0; k<node->cnt_arc; k++) {
      strcpy(trace, "  ");
      f_trace_sub(vara, node, arc++, trace);
    }
    vara++;
  }
}
//-----------------------------------------------------------------------------
int f_trace_sub (aVARA_t *vara, aNODE_t *node, aARC_t *arc, char *trace) {

  int    i;
  char   wrk[4096], num[10];

  if (arc->type == 'p') {
    printf("%s#%02d(%s)\n", trace, node->num, arc->cond);
    return;
  }

  node = vara->top_node + arc->end;

  sprintf(num, "%02d", node->num);
  if (strstr(trace, num)) {
    printf("%s#%02d(%s)...\n", trace, node->num, arc->cond);
  }
  else {
    sprintf(wrk, "%s#%02d(%s)", trace, node->num, arc->cond);
    arc  = node->top_arc;
    for (i=0; i<node->cnt_arc; i++) {
      f_trace_sub(vara, node, arc++, wrk);
    }
  }
}
//-----------------------------------------------------------------------------
int f_set_endp () {

  aVARA_t *vara;
  aNODE_t *node, *nx;
  aARC_t  *arc,  *ax;

  int   i, j, k, m;

  // arcendp 򥻥åȤ
  vara = aBASE.base_vara;
  for (i=0; i<aBASE.all_vara; i++) {
    node = vara->top_node;
    for (j=0; j<vara->cnt_node; j++) {
      arc = node->top_arc;
      for (k=0; k<node->cnt_arc; k++) {
	nx = vara->top_node;
	for (m=0; m<vara->cnt_node; m++) {
	  if (arc->end == nx->num) {
	    arc->endp = nx;
	    //vs("#endp %x  %-6s  n#%02d (2)\n", arc->endp, vara->name, nx->num);
	    break;
	  }
	  nx++;
	}
	arc++;
      }
      node++;
    }
    vara++;
  }

  // arc pop 򥻥åȤ
  for (i=0; i<aBASE.all_vara; i++) {
    vara = aBASE.base_vara + i;

    for (j=0; j<vara->cnt_node; j++) {
      node = vara->top_node + j;

      for (k=0; k<node->cnt_arc; k++) {
	arc = node->top_arc + k;

	if (nx = arc->endp) {
	  for (m=0; m<nx->cnt_arc; m++) {
	    ax = nx->top_arc + m;

	    if (ax->type == 'p') {
	      arc->pop = 1;
	      //vs("#pop %-6s  n#%02d %s\n", vara->name, node->num, arc->cond);
	      break;
	    }
	  }
	}
      }
    }
  }
}
//-----------------------------------------------------------------------------
int f_setup_data (char *src, char *top, char *end, char *cond, char *opt) {

  uchar *p1, *p2, *p3;

  //vs("\nsetup [%s]\n", src);

  if (memcmp(src, "arc(", 4) != 0)  fc_abort(";;; #1 arc 顼\n");
  if (fc_tail_char(src) != ')')     fc_abort(";;; #1 arc 顼\n");

  // arc(1,2,ADVE,*)
  //      | |    |
  //      | |    +-- p3 (NULL ⤢)
  //      | +-- p2
  //      +-- p1

  fc_tail_cut(src);  //  ')' 

  if (! (p1 = strchr(src,  ','))) fc_abort(";;; #2 arc 顼\n");
  if (! (p2 = strchr(p1+1, ','))) fc_abort(";;; #3 arc 顼\n");

  if (p3 = strchr(p2+1, ',')) *(p3++) = 0;  // p3 ---> *

  *(p1++) = 0;   // p1 ---> 2...
  *(p2++) = 0;   // p2 ---> ADVE...

  *top = atoi(src+4);    // Ρֹ (ex: 1)

  if (*top < 1) fc_abort(";;; #4 arc 顼\n");

  *end = atoi(p1);    // Ρֹ (ex: 2)
  strcpy(cond, p2);   // 

  if (p3 == NULL) *opt = 0;
  else            strcpy(opt, p3);

  //vs("top=%d end=%d cond=[%s] opt=[%s]\n", *top, *end, cond, opt);
}
/*-----------------------------------------------------------------------------
  ѿեϤơѿ

  arc (Ρ, Ρ, , ץ)

-----------------------------------------------------------------------------*/
int f_parse_atype (char kind, char *filename) {

  uchar  buf[4096], src[128][4096];
  int    terminate=1, i, n;
  FILE  *fp;
  aVARA_t *vara;

  int   pc;
  char  top[128];          // Ρֹ
  char  end[128];          // Ρֹ
  char  cond[128][4096];   // 
  char  opt [128][4096];   // ץ


  if ((fp = fopen(filename, "r")) == NULL)
    fc_abort(";;; can't open '%s'\n", filename);

  while (fgets(buf, 4095, fp) != NULL) {
    buf[strlen(buf)-1] = 0;

    //vs("\nbuf [%s]\n", buf);

    if (! (n = f_parse_string(buf, src))) continue;  // ԤɤФ

    for (i=0; i<n; i++) {
      //vs("src #%02d [%s]\n", i+1, src[i]);
    }


    if (terminate) { // ѿ̾νиԤ
      vara       = f_new_VARA();
      vara->name = f_store_FSTRING(src[0]);            // ѿ̾
      //vs("=== Aѿ̾ [%s] ===\n", src[0]);
      terminate = pc = 0;
      continue;
    }

    // ѿλ
    if (strcmp(src[0], "end") == 0) {
      f_setup_node(vara, pc, top, end, cond, opt);
      f_node_check(vara);  // node, arc å
      terminate = 1;
      continue;
    }

    // Ρ
    for (i=0; i<n; i++) {
      f_setup_data(src[i], &top[pc], &end[pc], &cond[pc][0], &opt[pc][0]);
      pc++;
    }

  } // end of while(fgets...)

  fclose(fp);
}
//-----------------------------------------------------------------------------
int f_setup_node (aVARA_t *vara, int pc, char top[], char end[],
		   char cond[][4096], char opt[][4096]) {

  int    i, j, max=0, f1=0, f2;
  aNODE_t  *node;
  aARC_t   *arc;

  // Ρֹκͤ
  for (i=0; i<pc; i++) {
    if (top[i] > max) max = top[i];
  }

  //vs("max = %d\n", max);

  for (i=1; i<=max; i++) {
    // Ρֹ = i ΥΡɤ
    f2 = 0;
    
    for (j=0; j<pc; j++) {
      if (top[j] == i) {  // ǡ
	if (f2 == 0) {    //   Ρ̤
	  node = f_new_NODE();
	  node->num = top[j];   // Ρֹ
	  f2 = 1;
	  if (f1 == 0) {
	    vara->top_node = node;  // ѿκǽΥΡ
	    f1 = 1;
	  }
	  vara->cnt_node++;  // Ρɿå
	}
	arc = f_new_ARC();
	if (node->cnt_arc == 0) node->top_arc = arc;  // ΡɤƬ
	node->cnt_arc++;  // å
	arc->top = top[j];
	arc->end = end[j];
	// 勵
	if      (fc_zenkaku_p(cond[j]))        arc->type = 'T'; // ñɽ
	else if (f_hyojun_p(cond[j]))          arc->type = 'H'; // ɸɽ
	else if (fc_hinsi_p(cond[j]))          arc->type = 'P'; // ʻ
	else if (strcmp(cond[j], "pop")  == 0) arc->type = 'p'; // ǽ٥
	else if (strcmp(cond[j], "jump") == 0) arc->type = 'j'; // ǽ٥
	else if (strcmp(cond[j], "!")    == 0) arc->type = '!'; // ǽ٥
	else if (strcmp(cond[j], "\\(....)\\")  == 0) arc->type = 'D';
	                                                      // ľܹ¤
	else arc->type = '?'; // ̤

	// ʸ
	if (arc->type == 'H') {       // ɸɽ  'xxxx'
	  cond[j][strlen(cond[j])-1] = 0;  // 'xxxx'  xxxx
	  arc->cond = f_store_FSTRING(&cond[j][1]);
	}
	else {
	  arc->cond = f_store_FSTRING(cond[j]);
	}

	// ץ
	if (strchr(opt[j], '*')) arc->opt_i = 1;
	if (strchr(opt[j], '^')) arc->opt_g = 1;
      }
    }
  }
}
/*-----------------------------------------------------------------------------
  ؿλ̥ޥå׺
-----------------------------------------------------------------------------*/
int f_make_jmap () {

  xVARS_t *vars = xBASE.base_vars;
  xJMAP_t *jmap = xBASE.base_jmap;

  int    i, j, cc, vc;
  uchar *valu, *p1, *p2, jizura[256];

  for (i=0; i<xBASE.all_vars; i++) {
    if (vars->type != 'Y') {
      vars++;
      continue;
    }
    //vs("\njmap <%s>\n", vars->name);
    switch (vars->ckind) {
    case 't':
    case 'h':
      valu = vars->cvalu;
      if (*valu != ' ') { // ñ
	jmap->mc[0] = f_make_jmap_sub(valu, &jmap->map[0][0]);
	jmap->cc = 1;
      }
      else {
	p1 = valu + 1;
	cc = 0;
	while (1) {
	  p2 = strchr(p1, ' ');
	  strcpy(jizura, fc_substr(p1, p2-1));
	  jmap->mc[cc] = f_make_jmap_sub(jizura, &jmap->map[cc][0]);
	  cc++;
	  p1 = p2 + 1;
	  if (*p1 == 0) break;
	}
	jmap->cc = cc;
      }
      break;
    case 'x':
      for (cc=0; cc<vars->cc; cc++) {
	jizura[0] = 0;
	for (vc=0; vc<vars->vc[cc]; vc++) {
	  if (strchr("TH", vars->kind[cc][vc])) {
	    strcat(jizura, vars->valu[cc][vc]);
	  }
	}
	if (jizura[0] != 0) {
	  j = jmap->cc;
	  jmap->mc[j] = f_make_jmap_sub(jizura, &jmap->map[j][0]);
	  jmap->cc++;
	}
      }
    }
    vars->jmap = jmap++;
    xBASE.all_jmap++;
    vars++;
  }

  //fc_show_yoso_jmap();
}
//-----------------------------------------------------------------------------
int f_make_jmap_sub (uchar *jizura, short *map) {

  int    i, mc=0;
  short  v, all[MAX_JMAP];
  uchar *p1;

  //vs("  sub [%s]\n", jizura);

  for (p1=jizura; *p1!=0; p1+=2) {
    v = *p1 * 256 + *(p1+1) - A1A1;
    //vs("  [%s] %d\n", fc_substr(p1, p1+1), v);
    for (i=0; i<mc; i++) {
      if (v == all[i]) break;
    }
    if (i == mc) {
      if (mc < MAX_JMAP) {
	all[mc++] = v;
	*map++ = v;
      }
    }
  }

  for (i=0; i<mc; i++) {
    //vs("(%d/%d) %d\n", i+1, mc, *save++);
  }

  return mc;
}
//-----------------------------------------------------------------------------
