/*-----------------------------------------------------------------------------
  ALTJAWSȤäǲϽ
-----------------------------------------------------------------------------*/

#include "alt_morph.h" /* ǲϥ饤֥ȤΤɬ */
#include "alt_error.h" /* 顼򻲾ȤΤɬ */
#include "aisystem.h"
#include "common.h"

//-----------------------------------------------------------------------------
int main (int argc, char *argv[]) {

  char  buf[256], lines[10], args[5][256], filename[256], *p1;
  int   i;
  FILE *inpf, *outf, *p_file;  

  f_set_args(argc, argv, args);

  if ((inpf = fopen(args[1], "r")) == NULL) {
    fprintf(stderr, ";;; ERROR: file open ʸե '%s'\n", args[1]);
    exit(-1);
  }

  if ((outf = fopen(args[2], "w")) == NULL) {
    fprintf(stderr, ";;; ERROR: file open ǥե '%s'\n", args[2]);
    exit(-1);
  }

  // ʸեιԿ
  sprintf(buf, "wc -l %s", args[1]);

  if (! (p_file = popen(buf,"r")))
    strcpy(lines, "?");
  else {
    fgets (buf, 80 ,p_file);
    i = atoi(buf);
    sprintf(lines, "%d", i);
    pclose (p_file );
  }

  if (fm_initialize(args[3])) exit(-1);

  fprintf(stderr, "\n;;; ALTJAWS start : '%s'   %s lines\n", args[1], lines);

  // ǥ쥯ȥʸե̾ filename ˳Ǽ

  strcpy(filename, args[1]);
  while (p1=strchr(filename, '/')) {
    strcpy(filename, p1+1);
  }

  while (fgets(buf, 4096, inpf)) {
    buf[strlen(buf)-1] = 0;
    if (fm_analyze(buf, filename) == 0) {
      fm_display(outf);
    }
  }

  fclose(inpf);
  fclose(outf);

  fm_terminate();

  fprintf(stderr, "\n;;; ALTJAWS finished\n\n");
}
//-----------------------------------------------------------------------------
int f_set_args (int argc, char *argv[], char args[4][256]) {

  if ((argc < 2) || (argc > 4)) f_usage(argv[0]);

  strcpy(args[1], argv[1]);
  sprintf(args[2], "morph.%s", args[1]);
  strcpy(args[3], "./ruigo.dic");

  switch (argc) {
  case 4:
    if (strcmp(argv[3], "-") != 0) strcpy(args[3], argv[3]);
  case 3:
    if (strcmp(argv[2], "-") != 0) strcpy(args[2], argv[2]);
  }

  fprintf(stderr, "\nʸե %s\n", args[1]);
  fprintf(stderr, "ǥե %s\n", args[2]);
  fprintf(stderr, "켭       %s\n", args[3]);
}
//-----------------------------------------------------------------------------
int f_usage (char *argv0) {

  // argc                   1    2     3    4  
  // argv                   0    1     2    3
  fprintf(stderr, "\nusage: %s  arg1 [arg2 arg3]\n\n", argv0);
  fprintf(stderr, "    arg1 = ʸե̾          (in)\n");
  fprintf(stderr, "    arg2 = ǥե̾          (out)\n");
  fprintf(stderr, "    arg3 = 켭(aisam)ե̾ (in)\n\n");
  exit(-1);
}
//-----------------------------------------------------------------------------
/*-----------------------------------------------------------------------------
  ALTJAWSȤäǲϽ
 
     ؿ  int fm_initialize (char[])
 
        : 
        : 켭(aisam)ե̾
        :  0 = ｪλ
              -1 = 顼ȯ (*2)
 
     ؿ  int fm_analyze (char[], char[])
 
        : ALTJAWSˤǲϤԤ̤򥰥Хѿ(*1)˳Ǽ
        : ʸ, ʸե̾
        :  0 = ｪλ
              -1 = 顼ȯ (*2)
 
     ؿ  int fm_terminate ()
 
        : ALTJAWSλ
        :  0 = ｪλ
              -1 = 顼ȯ (*2)
 
     ؿ  int fm_display (FILE *)
 
        : ǲϷ̤ɽ
        : ɽեݥ
        :  0 = ｪλ
              -1 = 顼ȯ (*2)
 
   (*1) CNT_MORP  ǿ
        jBASE[]   Ǿ

   (*2) 顼ɸ२顼˽Ϥ

 顼
   1  ѷͰ襨顼
   2  ͭʤ
   3  ɸɽû
   4  ɸɽθ㤦
   5  ͭʤ
   6  ǽ
   9  ơ֥ˤʤʻ쥳
-----------------------------------------------------------------------------*/
// ޥ

#define arraysize(arr) (sizeof((arr)) / sizeof((arr)[0]))
#define is_zenkaku(str) ((*(str) & 0x80) && (*((str)+1) & 0x80))

// Хѿ
int      CNT_MORP;             // ǿ
jMORP_t  jBASE[MAX_jMORP];     // Ǿ

int  MORPH_INIT_FLAG = 0;
char MORPH_JID[81];
char MORPH_JPN[256];

char  PDIC_NAME[256];  // ѥм񥤥ǥå̾

aiDes_t  PDIC_DES;     // ѥм񥤥ǥå(aisam)ǥץ
aiDes_t  KRDIC_DES;    // 켭(aisam)ǥץ

// VERB1357[x3-1][x4-1][0]
// x2 = 1,3,5,7
// x3 = 1,2,3,4,5,6,7,8,9
// x4 = 1,2,3,4,5,6,7,8,9
char VERB1357[9][9][6] = 
  {"","","","","xx","","","","",
   "","","","","xx","","","","",
   "","","","","xx","","","","",
   "","","","","xx","","","","",
   "","","","","xx","","","","",
   "","","","","xx","","","","",
   "","","","","xx","","","","",
   "","","","","xx","","","","",
   "","","","","xx","","","",""};

// VERB2468[x3-1][x4-1][0]
// x2 = 2,4,6,8
// x3 = 1,2,3,4
// x4 = 1,2,3,4,5,6,7,8,9
char VERB2468[9][9][6] =
  {"--","--","--","--","xx","","","","",
   "--","--","--","--","xx","--","--","--","--",
   "","","","","xx","","","","",
   "","","","","xx","","","","",
   "xx","xx","xx","xx","xx","xx","xx","xx","xx",
   "xx","xx","xx","xx","xx","xx","xx","xx","xx",
   "xx","xx","xx","xx","xx","xx","xx","xx","xx",
   "xx","xx","xx","xx","xx","xx","xx","xx","xx",
   "xx","xx","xx","xx","xx","xx","xx","xx","xx"};

char K310[9][6]    ={"","xx","xx","","","","","","xx"};
char K321_322[9][6]={"","xx","xx","","","","","ʤ","xx"};

typedef enum {
    False, True
} bool_t ;

/*--------------------------*/
/* ̾ơ֥ */
/*--------------------------*/
#define DEF_ALTJE_SYSTEM "/usr/local/altje"
#define DEF_DICTDIR      "/dict/isam/"
#define DEF_CATDIR       "/dict/rule/cat-dic/"
#define DEF_USERDIR      "/dict/isam/userdic/"

typedef enum {
    kanjiyog,
    kanjiich,
    katakana,
    hiragana,
    mazegaki,
    setuzoku,
    rengo, 
    gcate,
    pcate
} dictID_t ;

typedef struct {
    char *defDir ;
    char *defName ;
    char *name ;
} dictName_t ;

static dictName_t dictName[] = {
    {DEF_DICTDIR, "j_kanji_yogo" , NULL},
    {DEF_DICTDIR, "j_kanji_1moji", NULL},
    {DEF_DICTDIR, "j_katakana"   , NULL},
    {DEF_DICTDIR, "j_hiragana"   , NULL},
    {DEF_DICTDIR, "j_mazegaki"   , NULL},
    {DEF_DICTDIR, "setsuzoku"    , NULL},
    {DEF_DICTDIR, "rengot"       , NULL},
    {DEF_CATDIR, "cat-g.txt"   , NULL},
    {DEF_CATDIR, "cat-p.txt"   , NULL},
} ;

static dictName_t userName[] = {
    {DEF_USERDIR, "userdicy_j" , NULL},
    {DEF_USERDIR, "userdic1_j" , NULL},
    {DEF_USERDIR, "kinoudic1_j", NULL},
    {DEF_USERDIR, "chotatsu-cat_j" , NULL},
} ;

// ؿץȥ

int  fm_analyze    (char[], char[]);
int  fm_terminate  ();
int  fm_display    (FILE*);

int  fm_initialize ();
int  fm_save       ();

void  fm_display_NI    (FILE *, int, short*, int);
void  fm_display_NK    (FILE *, int, char*,  int);

void  fm_display_bit_position (FILE *, int);

int   fm_init_dictname   (char[], dictName_t*) ;
void  fm_alt_error       (char[], ...) ;
void  fm_error           (char [], ...) ;
int   fm_make_katuyo     (char[], char[], char[], char*);
int   fm_count_cat_short (int, short*);
int   fm_count_cat_char  (int, char*);

int   fm_kana_p          (char*src) ;
void  fm_jstring_trim    (char[], char[], int ) ;

int   fm_adj_adv_katuyo_sub (char *, char *, char *, char [][6], char, char *);
int   fm_scan_pdic (char *nhyo, char yzok[]);

//-----------------------------------------------------------------------------
/*-----------------------------------------------------------------------------
    jpn = "id:ʸ"  or "ʸ"
        filename = ǥ쥯ȥʸե̾
-----------------------------------------------------------------------------*/
int fm_analyze (char jpn[], char filename[]) {

  char  *p1;
  bool_t use_user = False;

  if (MORPH_INIT_FLAG == 0) {
    fm_error("missing initialize");
    return -1;
  }

  if (p1 = strchr(jpn, ':')) {
    strncpy(MORPH_JID, jpn, (int)(p1-&jpn[0]));
    strcpy (MORPH_JPN, p1+1);
  }
  else {
    //strcpy(MORPH_JID, "xxxx");
    strcpy(MORPH_JID, filename);
    strcpy(MORPH_JPN, jpn);
  }

  /*
  if (strcmp(&MORPH_JPN[strlen(MORPH_JPN)-1], "") != 0)
    strcat(MORPH_JPN, "");
  */

  /* -- LIBRARY -- ǲϤμ¹ -- */
  if (alt_morphExec(MORPH_JPN, strlen(MORPH_JPN), 23, 0, (int)use_user)
      != ALT_NORMAL) {
    fm_alt_error("Exec Error(%s)", MORPH_JPN);
    return -1;
  }
    
  // Ϸ̤γǼ
    
  if (fm_save() == -1) {
    fm_alt_error("Result Error(%s)", MORPH_JPN);
    return -1;
  }

  return 0;
}
//-----------------------------------------------------------------------------
int fm_terminate () {

  /* -- LIBRARY -- ǲϤνλ -- */
  if (alt_morphEnd() != ALT_NORMAL) {
    fm_alt_error("End Error");
    return -1;
  }

  aiClsIsam(PDIC_DES);
  aiClsIsam(KRDIC_DES);

  MORPH_INIT_FLAG = 0;

  return 0;
}
/*-----------------------------------------------------------------------------
  ǲϷ̤ɽ
-----------------------------------------------------------------------------*/
int fm_display (FILE *fp) {

  int   i, j, k;
  jMORP_t  *morp;
  jINFO_t  *info;

  fprintf(fp, "INPUT=%s", MORPH_JID);
  fm_display_bit_position(fp, strlen(MORPH_JPN) / 2); // ʸʸ֥ӥå
  fm_display_bit_position(fp, CNT_MORP-1);            // ǰ֥ӥå
  fprintf(fp, "\n%s\n", MORPH_JPN);

  for (i=0; i<CNT_MORP; i++) {

    morp = &jBASE[i];

    // ֹ ե饰 ñɽ  ex: '1. /'
    fprintf(fp, "%d. %c%s", morp->knum, morp->flag, morp->tang);

    for (j=0; j<morp->cnt_info; j++) {

      info = &morp->info[j];

      // ʻ   ex: '(1500'
      fprintf(fp, "(");
      if ((strcmp(info->hink, "0110") == 0) &&
	  (strcmp(morp->tang, "")   == 0)) {
	fprintf(fp, "[P]");
      }
      fprintf(fp, "%s", info->hink);

      if (strcmp(morp->tang, info->nhyo) != 0) {  // ñɽɸɽ
	// ɸɽ  ex: ','
	fprintf(fp, ",%s", info->nhyo);
	// ѷ  ex: ','
	if (info->katu[0] != 0) fprintf(fp, ",%s", info->katu);
      }

      if (info->cnt_icat + info->cnt_kcat + info->cnt_yzok) {
	fprintf(fp, ",{");
	fm_display_NI(fp, info->cnt_icat, info->cat.icat, 0);
	fm_display_NK(fp, info->cnt_kcat, info->cat.kcat, info->cnt_icat);

	if ((info->cnt_icat + info->cnt_kcat) && info->cnt_yzok)
	  fprintf(fp, ",");
	
	for (k=0; k<info->cnt_yzok; k++) {
	  if (k > 0) fprintf(fp, ",");
	  fprintf(fp, "NY:%d", info->yzok[k]);
	}

	fm_scan_ruigo(1, fp, info->nhyo);
	fprintf(fp, "}");
      }
      else {
	fm_scan_ruigo(0, fp, info->nhyo);
      }

      fprintf(fp, ")");
    }
    fprintf(fp, "\n");
  }
  
  return 0;
}
//-----------------------------------------------------------------------------
int fm_initialize (char *ruidic) {

  bool_t use_user = False;
  int i ;
  char *altje ;
  dictName_t p_index;
  char  p_index_name[20]="p_index.dic";

  /* ɸĶ */
  if ((altje = getenv("ALTJE_SYSTEM")) == NULL) {
    altje = DEF_ALTJE_SYSTEM ;
  }

  /* ƥ༭̾ */
  for (i = 0 ; i < arraysize(dictName) ; i++) {
    if (fm_init_dictname(altje, &dictName[i]) != 0) {
      return -1 ;
    }
  }

  /* ѼԼ̾ */
  for (i = 0 ; i < arraysize(userName) ; i++) {
    if (fm_init_dictname(altje, &userName[i]) != 0) {
      return -1 ;
    }
  }    

  /* ѥХǥå̾ : NY ˻ */

  memcpy(&p_index, &dictName[0], sizeof(dictName_t));
  p_index.defName = p_index_name;

  if (fm_init_dictname(altje, &p_index) != 0) {
    return -1 ;
  }

  strcpy(PDIC_NAME, p_index.name);

  /* -- LIBRARY -- ǲϤν -- */
  if (alt_morphInit(dictName[kanjiyog].name,
		    dictName[kanjiich].name,
		    dictName[katakana].name,
		    dictName[hiragana].name,
		    dictName[mazegaki].name,
		    dictName[setuzoku].name,
		    dictName[rengo].name,
		    dictName[gcate].name,
		    dictName[pcate].name) != ALT_NORMAL) {
    fm_alt_error("Init Error");
    return ALT_ERROR;
  }
  
  /* -- LIBRARY -- ѼԻ꼭Υץ -- */
  if (alt_morphOpenUserDict(ALT_USER_DICT,
			    userName[0].name,
			    userName[1].name,
			    userName[2].name,
			    "") == ALT_NORMAL) {
    use_user = True;
  } else {
    use_user = False;
    fm_alt_error("User Open Error:");
    /* Not Exit */
  }

  if ((PDIC_DES=aiOpnIsam(PDIC_NAME,AI_RO)) == NULL)  {
    fm_error(";;; ERROR file open ѥм '%s'\n;;; aiOpnIsam , aistatus [%d]\n",
	     PDIC_NAME, aistatus);
    return -1;
  }
  
  if ((KRDIC_DES=aiOpnIsam(ruidic,AI_RO)) == NULL)  {
    fm_error(";;; ERROR file open 켭 '%s'\n;;; aiOpnIsam , aistatus [%d]\n",
	     ruidic, aistatus);
    return -1;
  }
  
  MORPH_INIT_FLAG = 1;

  return 0;
}
//-----------------------------------------------------------------------------
int fm_save () {

  int ret, knum=0;
  alt_morph_t morph;
  char trimtang[61], trimnhyo[61];

  int   bsno=0;  // ʸֹ
  int   btno=0;  // ʸֹ

  jMORP_t  *morp;
  jINFO_t  *info;

  /* -- LIBRARY -- ǲϷ̤μ(1) -- */

  if (alt_morphResult(0, &morph) != ALT_NORMAL) return -1;

  CNT_MORP = -1;

  // Ϸ̤ν
  do {
    if (bsno != morph.bsno) {  // ʸ᤬Ѥä
      bsno = morph.bsno;
      btno = 0;
    }

    fm_jstring_trim(trimtang, morph.tang, 60); // ñɽ
    fm_jstring_trim(trimnhyo, morph.nhyo, 60); // ɸɽ

    if (btno != morph.btno) { // ֹ椬Ѥä or ʸƬ

      CNT_MORP++;  // ǿå (ʸϤǤƬǤʤ飰ˤʤ)

      morp = &jBASE[CNT_MORP];

      memset(morp, 0x00, sizeof(jMORP_t));  // 0x00 clear

      // ǰϢֹ
      morp->knum = ++knum;

      // ʸᶭե饰
      morp->flag = (btno == 0) ? '/' : '+';

      strcpy(morp->tang, trimtang);  // ɽ
      morp->cnt_info = 0;

      btno = morph.btno;
    }

    info = &morp->info[morp->cnt_info];

    memcpy(info->hink,  morph.hink, 4);  // ʻ
    info->hink[4] = 0;

    // ɸɽ
    strcpy(info->nhyo, trimnhyo);

    // ѷ
    fm_make_katuyo(info->hink, morp->tang, info->nhyo, info->katu);

    // ̣°
    memcpy(&info->cat, &morph.jrtg, sizeof(morph.jrtg));
    info->cnt_yzok = fm_scan_pdic(info->nhyo, info->yzok);

    // ̣°ͭ򥫥Ȥ
    info->cnt_icat = fm_count_cat_short( 5, info->cat.icat);
    info->cnt_kcat = fm_count_cat_char (10, info->cat.kcat);

    if (morp->cnt_info == MAX_jMORP) {
      fprintf(stderr, ";;; ERROR: exceed MAX_jMORP\n");
      exit(-1);
    }

    morp->cnt_info++;

    /* -- LIBRARY -- ǲϷ̤μ(2ܰʹ) -- */

  } while ((ret = alt_morphResult(1, &morph)) == ALT_NORMAL);
	   
  if (ret == ALT_ERROR) return -1;

  // ü(/nil)Ͽ
  morp++;
  memset(morp, 0x00, sizeof(jMORP_t));  // 0x00 clear
  morp->knum = ++knum;
  morp->flag = '/';
  strcpy(morp->tang, "nil");

  CNT_MORP += 2;  // ǿǽå (ˤʤ)

  return  0;
}
//-----------------------------------------------------------------------------
// ̣°ͭ򥫥Ȥ & ͭȥͤˤ (short type)
//-----------------------------------------------------------------------------
int fm_count_cat_short (int max, short *cat) {

  int   i, cnt=0;
  short *shift=cat;

  for (i=0; i<max; i++) {
    if (*cat != 0) {   // ͭȥ
      cnt++;               // 
      if (cat == shift) {  // ͤɬפʤ
	shift++;
      }
      else {
	*shift++ = *cat;   // ˵ͤ
	*cat = 0;          // 򥯥ꥢ
      }
    }
    cat++;
  }

  return(cnt);
}
//-----------------------------------------------------------------------------
// ̣°ͭ򥫥Ȥ & ͭȥͤˤ (char type)
//-----------------------------------------------------------------------------
int fm_count_cat_char (int max, char *cat) {

  int   i, cnt=0;
  char *shift=cat;

  for (i=0; i<max; i++) {
    if (*cat != 0) {   // ͭȥ
      cnt++;               // 
      if (cat == shift) {  // ͤɬפʤ
	shift++;
      }
      else {
	*shift++ = *cat;   // ˵ͤ
	*cat = 0;          // 򥯥ꥢ
      }
    }
    cat++;
  }

  return(cnt);
}
//-----------------------------------------------------------------------------
int fm_kana_p (char *src) {

  int   i;

  for (i=0; i<strlen(src); i+=2) {
    if (memcmp(src+i, "", 2) >= 0) return 0;
  }

  return(1);
}
/*-----------------------------------------------------------------------------
  ̾1Ľ
-----------------------------------------------------------------------------*/
int fm_init_dictname (char altje[], dictName_t *dict) {

  char *name ;

  if ((name = malloc(strlen(altje)+
		     strlen(dict->defDir)+
		     strlen(dict->defName)+1)) == NULL) {
    return -1 ;
  }
  sprintf(name, "%s%s%s", altje, dict->defDir, dict->defName) ;
  dict->name = name ;
  return 0 ;
}
/*-----------------------------------------------------------------------------
  ALTJAWS¦Υ顼ɽ
-----------------------------------------------------------------------------*/
void fm_alt_error (char message[], ...) {

  va_list ap ;

  va_start(ap, message) ;
  vfprintf(stderr, message, ap) ;
  fprintf(stderr, "\n");
  /* -- LIBRARY -- 顼ɽ -- */
  fprintf(stderr,
	  " =>lvl:[%d]\n   typ:[%d]\n   inf:[%d]\n   pos:[%s]\n",
	  alt_errorLevel, alt_errorType, alt_errorInfo, alt_errorPosition) ;
  va_end(ap) ;
}
/*-----------------------------------------------------------------------------
  morph¦Υ顼ɽ
-----------------------------------------------------------------------------*/
void fm_error (char message[], ...) {

  va_list ap ;

  fprintf(stderr, "----- error -----\n");
  va_start(ap, message) ;
  vfprintf(stderr, message, ap) ;
  fprintf(stderr, "\n-----------------\n");
  va_end(ap) ;
}
/*-----------------------------------------------------------------------------
  (/Ⱦ)
-----------------------------------------------------------------------------*/
void fm_jstring_trim (char dst[], char src[], int len) {

  int i, pos ;

  i = pos = 0 ;
  while (i < len) {
    if (i < len-1 && is_zenkaku(src)) {
      if (strncmp(&src[i], "", 2) != 0) {
	pos = i + 2 ;
      }
      i += 2 ;
    } else {
      if (src[i] != ' ') {
	pos = i + 1 ;
      }
      i++ ;
    }
  }
  strncpy(dst, src, pos) ;
  dst[pos] = '\0' ;
}
//-----------------------------------------------------------------------------
void fm_display_NI (FILE *fp, int cnt, short cat[], int bef) {

  int  i;
  char delim[2]="";

  if (cnt > 0) {
    if (bef) strcpy(delim, ",");
    for (i=0; i<cnt; i++) {
      fprintf(fp, "%sNI:%d", delim, cat[i]);
      strcpy(delim, ",");
    }
  }
}
//-----------------------------------------------------------------------------
void fm_display_NK (FILE *fp, int cnt, char cat[], int bef) {

  int  i;
  char delim[2]="";

  if (cnt > 0) {
    if (bef) strcpy(delim, ",");
    for (i=0; i<cnt; i++) {
      fprintf(fp, "%sNK:%d", delim, cat[i]);
      strcpy(delim, ",");
    }
  }
}
//-----------------------------------------------------------------------------

/*
ʸʸ֥ӥåȡ

1. ʸ % 4 = n ΤȤn ͤˤ v1 ɽ

  n=0  v1=NULL (ɽʤ)
  n=1  v1=1
  n=2  v1=2
  n=3  v1=7

2. ʸ / 4 = v2 Ȥᡢv2 θĿ 'f' ɽ

                  1 1 1 1 1 1 1 1 1 1
1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9
ϺդλŹȤ˵ޤǵä  (19ʸ)

19 % 4 = 3  '0x7' ɽ
19 / 4 = 4  'ffff' ɽ

 ֥ӥåȡ

ʸʸ֥ӥåȤˤʸפǿִƽ

                                       1    1  1
1    2  3    4  5    6    7  8  9      0    1  2
Ϻ    Ź    ޤ     (12)

12 % 4 = 0  '0x' ɽ
12 / 4 = 3  'fff' ɽ

*/
void  fm_display_bit_position (FILE *fp, int kazu) {

  int   i, v1, v2;

  v1 = kazu % 4;
  v2 = kazu / 4;

  fprintf(fp, "=0x");

  switch (v1) {
  case 1: fprintf(fp, "1"); break;
  case 2: fprintf(fp, "3"); break;
  case 3: fprintf(fp, "7"); break;
  }

  for (i=0; i<v2; i++) fprintf(fp, "f");
}
//-----------------------------------------------------------------------------
int fm_make_katuyo (char hink[], char tang[], char nhyo[], char *katu) {

  int  ret;
  char x2, x3, x4;

  if (! strchr("23", hink[0])) return 0; // ư/ƻ/ưǤʤ
  if (hink[3] == '0')          return 0; // ѷ
  if (strcmp(tang, nhyo) == 0) return 0; // ñɽɸɽ
  if (! fm_kana_p(tang))       return 0; // ɽǤʤ
  
  //fprintf(stderr, "@@@ %s %s %s\n", hink, nhyo, katu);

  x2 = hink[1];
  x3 = hink[2];
  x4 = hink[3];

  // 2232, 2432, 2632, 2832   //
  // 2239, 2439, 2639, 2839   /

  // 2242, 2442, 2642, 2842   //
  // 2249, 2449, 2649, 2849   /

  // 3215, 3225  /

  if (hink[0] == '2') {
    if (strchr("1357",      x2) &&
	strchr("123456789", x3) &&
	strchr("123456789", x4)) {
      ret = fm_verb_katuyo(hink, nhyo, katu, VERB1357);
    }
    else if (strchr("2468",      x2) &&
	     strchr("1234",      x3) &&
	     strchr("123456789", x4)) {
      ret = fm_verb_katuyo(hink, nhyo, katu, VERB2468);
    }
  }
  else if (memcmp(hink,"310", 3) == 0) {
    ret = fm_adj_adv_katuyo(hink, nhyo, katu, K310);
  }
  else if (memcmp(hink,"321", 3) == 0) {
    ret = fm_adj_adv_katuyo(hink, nhyo, katu, K321_322);
  }
  else if (memcmp(hink,"322", 3) == 0) {
    ret = fm_adj_adv_katuyo(hink, nhyo, katu, K321_322);
  }
  else {
    ret = 9;
  }

  if (ret) { // 顼
    //fprintf(stderr, ";;; ERROR: ѷ (#%d) %s %s\t%s\n", ret, hink, tang, nhyo);
  }
  else {
    //printf("@OK: %s %s %s\n", hink, nhyo, katu);
  }

  return 1;
}
//-----------------------------------------------------------------------------
int fm_verb_katuyo (char *hink, char *nhyo, char *katu,
			char gobiList[9][9][6]) {

  char  del[81], add[81], x3, x4;

  x3 = *(hink + 2) - '1';
  x4 = *(hink + 3) - '1';

  strcpy(del, &gobiList[x3][ 5][0]); // ߷θ
  strcpy(add, &gobiList[x3][x4][0]); // ѷθ

  return (fm_katuyo(hink, nhyo, katu, del, add));
}
//-----------------------------------------------------------------------------
int fm_adj_adv_katuyo (char *hink, char *nhyo, char *katu,
		       char gobiList[][6]) {

  char  del[81], add[81], x4;
  int   ret=0;

  // ƻ/ư, ɸɽǤ˳ѷΥ

  // ü쥱 3215, 3225  /

  if (strstr(" 3215 3225 ", hink)) {
    if (fm_katuyo(hink, nhyo, katu, "", "") == 0) return 0;
    if (fm_katuyo(hink, nhyo, katu, "", "") == 0) return 0;
  }

  x4 = *(hink + 3);

  if ((x4 < '1') || (x4 > '9')) return 1;  // ѷͰ襨顼

  x4 -= '1';  // x4 = 0  8

  strcpy(del, &gobiList[x4][0]); // ѷθ
  strcpy(add, &gobiList[x4][0]); // ѷθ (?? Ѥˤ⤦)

  if (fm_katuyo(hink, nhyo, katu, del, add)) {
    strcpy(del, &gobiList[ 5][0]);  // θ
    ret = fm_katuyo(hink, nhyo, katu, del, add);
  }

  return ret;
}
//-----------------------------------------------------------------------------
int fm_katuyo (char *hink, char *nhyo, char *katu, char del[], char add[]) {

  char  gokan[81], len1, len2;

  if (del[0] == 'x') return 2;  // ͭʤ

  // ɸɽ(nhyo)(del)  gokan

  len1 = strlen(nhyo);
  len2 = strlen(del);

  if (len1 < len2) return 3;  // ɸɽû

  if (memcmp(nhyo+len1-len2, del, len2) != 0) return 4; // ɸɽθ㤦

  strcpy(gokan, nhyo);
  gokan[len1-len2] = 0;

  // gokan + Ϳ(add)  katu

  if (add[0] == 'x') return 5;  // ͭʤ

  if (add[0] == '-') {
    strcpy(katu, gokan);
    //printf("@--: %s %s %s\n", hink, nhyo, gokan);
  }
  else
    sprintf(katu, "%s%s", gokan, add);

  return 0;
}
//-----------------------------------------------------------------------------
int fm_scan_ruigo (int flag, FILE *fp, char *nhyo) {

  char  *p1;
  char  rec[256], key[61];

  if (fm_scan_ruigo_sub(flag, fp, nhyo, 0, ""))     return 0;
  if (fm_scan_ruigo_sub(flag, fp, nhyo, 1, "")) return 0;
  if (fm_scan_ruigo_sub(flag, fp, nhyo, 1, ""))   return 0;
  if (fm_scan_ruigo_sub(flag, fp, nhyo, 1, ""))   return 0;
  if (fm_scan_ruigo_sub(flag, fp, nhyo, 1, ""))   return 0;
  if (fm_scan_ruigo_sub(flag, fp, nhyo, 1, ""))   return 0;

  // ʲϥǥХåѤʤΤǤǵ
  return 0;

  // 
  memset(key, 0x20, sizeof(key));
  memcpy(key, nhyo, strlen(nhyo));
  key[60] = 0;

  if (aiReadRec(KRDIC_DES, rec, AI_LT, key, 1) == AI_OK) {
    memcpy(key, &rec[8], 60);
    key[60] = 0;
    if (p1 = strchr(key, ' ')) *p1 = 0;
    fprintf(stdout, ">>> LE %-20s (nhyo %s)\n", key, nhyo);
  }

  if (aiReadRec(KRDIC_DES, rec, AI_GT, key, 1) == AI_OK) {
    memcpy(key, &rec[8], 60);
    key[60] = 0;
    if (p1 = strchr(key, ' ')) *p1 = 0;
    fprintf(stdout, ">>> GE %-20s (nhyo %s)\n", key, nhyo);
  }

  return 0;
}
//-----------------------------------------------------------------------------
int fm_scan_ruigo_sub (int flag, FILE *fp, char *nhyo, int kind, char *gobi) {

  char  rec[256];
  char  key[61], work[256];

  strcpy(work, nhyo);

  switch (kind) {
  case 1: // nhyo 
    if (strlen(nhyo) <= strlen(gobi)) return 0;
    if (strcmp(nhyo+strlen(nhyo)-strlen(gobi), gobi) != 0) return 0;
    work[strlen(work)-strlen(gobi)] = 0;
    break;
  }

  memset(key, 0x20, sizeof(key));
  memcpy(key, work, strlen(work));
  key[60] = 0;

  if (aiReadRec(KRDIC_DES, rec, AI_EQ, key, 1) != AI_OK) return 0;

  rec[7] = 0;

  if (flag == 0) {
    fprintf(fp, ",{KR:%s", rec);
  }
  else {
    fprintf(fp, ",KR:%s", rec);
  }

  while (1) {
    if (aiReadRec(KRDIC_DES, rec, AI_NEXT, key, 1) != AI_OK) break;
    //if (memcmp(&rec[8], nhyo, 60) != 0) break;
    if (memcmp(&rec[8], key, 60) != 0) break;
    rec[7] = 0;
    fprintf(fp, ",KR:%s", rec);
    //fprintf(stderr, "KR:%s %s\n", rec, nhyo);
    //fflush(stderr);
  }

  if (flag == 0) fprintf(fp, "}");

  return 1;
}
//-----------------------------------------------------------------------------
int f_test_pdic () {

  int    i;
  char  rec[256]; // ºݤ 134 ,ǰΤ
  char  key[31];

  if (aiReadRec(PDIC_DES, rec, AI_FIRST, key, 0) != AI_OK) {
    fprintf(stderr, "NG: FIRST\n");
    exit(-1);
  }


  key[30] = 0;

  while (1) {
    memcpy(key, rec, 30);
    fprintf(stderr, "%s ", key);
    for (i=50; i<60; i+=2) {
      if (rec[i] > 0) {
	fprintf(stderr, " == %02d-%02d", rec[i], rec[i+1]);
      }
    }
    fprintf(stderr, "\n");
    if (aiReadRec(PDIC_DES, rec, AI_NEXT, key, 0) != AI_OK) break;
  }
}
//-----------------------------------------------------------------------------
int fm_scan_pdic (char *nhyo, char yzok[]) {

  int    i;
  char  rec[256]; // ºݤ 134 ,ǰΤ
  char  key[31], wrk[256], code[5];
  char  cnt_yzok;

  //fprintf(stderr, "pdic nhyo [%s]\n", nhyo);

  memset(key, 0xA1, sizeof(key));
  memcpy(key, nhyo, strlen(nhyo));

  key[30] = wrk[0] = cnt_yzok = 0;

  if (aiReadRec(PDIC_DES, rec, AI_EQ, key, 0) != AI_OK) return 0;

  while (1) {
    for (i=50; i<60; i+=2) {
      if (rec[i] > 0) {
	//sprintf(code, "%02d%02d", rec[i], rec[i+1]);
	sprintf(code, "%02d", rec[i]);
	if (! strstr(wrk, code)) {
	  if (cnt_yzok < MAX_IMIZ) yzok[cnt_yzok++] = rec[i];
	  sprintf(&wrk[strlen(wrk)], " %s ", code);
	}
      }
    }
    if (aiReadRec(PDIC_DES, rec, AI_NEXT, key, 0) != AI_OK) break;
    if (memcmp(rec, key, 30) != 0) break;
  }

  return(cnt_yzok);
}
//-----------------------------------------------------------------------------
